unit DAttributesForm;

interface

{HP 020 HYPSOGRAPHY
HY 050 HYDROGRAPHY
SC 070 VEG SURFACE COVER
NV 080 NON-VEG FEATURES
BD 090 BOUNDARIES
SM 150 SURVEY CONTROL
RD 170 ROADS AND TRAILS
RR 180 RAILROADS
MTS 190 PIPE & TRANS LINES
MS 200 MANMADE FEATURES
PL 300 PUBLIC LAND SURVEYS
600 Supplemental PLSS}

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls;

type
  TAttributesForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    HPMinor: TEdit;
    Label3: TLabel;
    LineCountDisplay: TLabel;
    HPDescriptive: TEdit;
    HPPMajor: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    HPPMinor: TEdit;
    ObjectTypeRG: TRadioGroup;
    Label6: TLabel;
    HYMinor: TEdit;
    HYDescriptive: TEdit;
    HYPMajor: TEdit;
    HYPMinor: TEdit;
    SCMinor: TEdit;
    SCDescriptive: TEdit;
    SCPMajor: TEdit;
    SCPMinor: TEdit;
    NVMinor: TEdit;
    NVDescriptive: TEdit;
    NVPMajor: TEdit;
    NVPMinor: TEdit;
    BDMinor: TEdit;
    BDDescriptive: TEdit;
    BDPMajor: TEdit;
    BDPMinor: TEdit;
    SMMinor: TEdit;
    SMDescriptive: TEdit;
    SMPMajor: TEdit;
    SMPMinor: TEdit;
    RDMinor: TEdit;
    RDDescriptive: TEdit;
    RDPMajor: TEdit;
    RDPMinor: TEdit;
    RRMinor: TEdit;
    RRDescriptive: TEdit;
    RRPMajor: TEdit;
    RRPMinor: TEdit;
    MTSMinor: TEdit;
    MTSDescriptive: TEdit;
    MTSPMajor: TEdit;
    MTSPMinor: TEdit;
    MSMinor: TEdit;
    MSDescriptive: TEdit;
    MSPMajor: TEdit;
    MSPMinor: TEdit;
    PLMinor: TEdit;
    PLDescriptive: TEdit;
    PLPMajor: TEdit;
    PLPMinor: TEdit;
    SPLMinor: TEdit;
    SPLDescriptive: TEdit;
    SPLPMajor: TEdit;
    SPLPMinor: TEdit;
    HelpBtn: TSpeedButton;
    EditBtn: TSpeedButton;
    EditAttributeEdit: TEdit;
    DisplayBtn: TSpeedButton;
    Bevel1: TBevel;
    Label4: TLabel;
    HP020CB: TCheckBox;
    HY050CB: TCheckBox;
    SC070CB: TCheckBox;
    NV080CB: TCheckBox;
    BD090CB: TCheckBox;
    SM150CB: TCheckBox;
    RD170CB: TCheckBox;
    RR180CB: TCheckBox;
    MTS190CB: TCheckBox;
    MS200CB: TCheckBox;
    PL300CB: TCheckBox;
    SPL600CB: TCheckBox;
    CloseBtn: TSpeedButton;
    AttUpDown: TUpDown;
    SetObjectBtn: TSpeedButton;
    NewBtn: TSpeedButton;
    LineMaxCountDisplay: TLabel;
    Label7: TLabel;
    EditMinor: TEdit;
    EditDescriptive: TEdit;
    EditPMajor: TEdit;
    EditPMinor: TEdit;
    SpeedButton1: TSpeedButton;
    UpDown1: TUpDown;
    NewEdit: TEdit;
    SpeedButton2: TSpeedButton;
    EditLayer: TEdit;
    UpDown2: TUpDown;
    procedure FormCreate(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
procedure SetAttribute;
    procedure DisplayBtnClick(Sender: TObject);
procedure GetMajorAttribute;
procedure SetMajorAttribute;
    procedure SetObjectBtnClick(Sender: TObject);
    procedure NewBtnClick(Sender: TObject);
    procedure EditBtnClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { Private declarations }
procedure AddAttribute;
  public
    { Public declarations }
  end;
{Main form: Changing Layer Sets Major Attribute.check

Get allows changing ObjectLayer <> not the same as CurrentLayer
Get .checked => sets Layer
Set currentlayer Sets .checked
Set Attribute : Current Object, Object type (0,1,2,3), Object Number
Layer 0..11
Objwect Type 1,3,5
Count 1...
Major 20,50,70,...
}
var
  AttributesForm: TAttributesForm;
  ObjectType,ObjectLayer,ObjectNumber:Integer;

implementation

{$R *.DFM}
uses DGlobalsUnit, DigitizerMain, DDLGCodesForm;

procedure TAttributesForm.FormCreate(Sender: TObject);
begin
  left := AttributesFormX;
  top := AttributesFormY;
end;

procedure TAttributesForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if (bAttributesToggled) then Action := caHide else
  begin
    AttributesFormX := AttributesForm.left;
    AttributesFormY := AttributesForm.top;
    DoSaver;
    Action := caFree;
  end;
end;
procedure TAttributesForm.CloseBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TAttributesForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(4000);
end;


{Automate except if already done
 and the form is picked to show.. just to look at}
procedure TAttributesForm.FormShow(Sender: TObject);
begin
  SetMajorAttribute;
  If (not bAttributesToggled) then
  begin
    bAttributesToggled := True;
    SetAttribute;
  end;
end;

procedure TAttributesForm.SetMajorAttribute;
Begin
  HP020CB.Checked :=False;
  HY050CB.Checked :=False;
  SC070CB.Checked :=False;
  NV080CB.Checked :=False;
  BD090CB.Checked :=False;
  SM150CB.Checked :=False;
  RD170CB.Checked :=False;
  RR180CB.Checked :=False;
  MTS190CB.Checked :=False;
  MS200CB.Checked :=False;
  PL300CB.Checked :=False;
  SPL600CB.Checked :=False;
  Case CurrentLayer of
  0:HP020CB.Checked :=True;
  1:HY050CB.Checked :=True;
  2:SC070CB.Checked :=True;
  3:NV080CB.Checked :=True;
  4:BD090CB.Checked :=True;
  5:SM150CB.Checked :=True;
  6:RD170CB.Checked :=True;
  7:RR180CB.Checked :=True;
  8:MTS190CB.Checked :=True;
  9:MS200CB.Checked :=True;
  10:PL300CB.Checked :=True;
  11:SPL600CB.Checked :=True;
  end;
End;


{Get Clear and Set ObjectLayer and 1 of the layer Checkers}
procedure TAttributesForm.GetMajorAttribute;
Begin
  If HP020CB.Checked then ObjectLayer:=0 else
  If HY050CB.Checked then ObjectLayer:=1 else
  If SC070CB.Checked then ObjectLayer:=2 else
  If NV080CB.Checked then ObjectLayer:=3 else
  If BD090CB.Checked then ObjectLayer:=4 else
  If SM150CB.Checked then ObjectLayer:=5 else
  If RD170CB.Checked then ObjectLayer:=6 else
  If RR180CB.Checked then ObjectLayer:=7 else
  If MTS190CB.Checked then ObjectLayer:=8 else
  If MS200CB.Checked then ObjectLayer:=9 else
  If PL300CB.Checked then ObjectLayer:=10 else
  If SPL600CB.Checked then ObjectLayer:=11 else
     HP020CB.Checked:=True;
  If HP020CB.Checked then ObjectLayer:=0;
  HP020CB.Checked :=False;
  HY050CB.Checked :=False;
  SC070CB.Checked :=False;
  NV080CB.Checked :=False;
  BD090CB.Checked :=False;
  SM150CB.Checked :=False;
  RD170CB.Checked :=False;
  RR180CB.Checked :=False;
  MTS190CB.Checked :=False;
  MS200CB.Checked :=False;
  PL300CB.Checked :=False;
  SPL600CB.Checked :=False;
  Case ObjectLayer of
  0:HP020CB.Checked :=True;
  1:HY050CB.Checked :=True;
  2:SC070CB.Checked :=True;
  3:NV080CB.Checked :=True;
  4:BD090CB.Checked :=True;
  5:SM150CB.Checked :=True;
  6:RD170CB.Checked :=True;
  7:RR180CB.Checked :=True;
  8:MTS190CB.Checked :=True;
  9:MS200CB.Checked :=True;
  10:PL300CB.Checked :=True;
  11:SPL600CB.Checked :=True;
  end;
End;

procedure TAttributesForm.SetAttribute;
begin
  if bPointMode then
  Begin
    LineCountDisplay.Caption := MakeItAString(CurrentPoint);
    ObjectTypeRG.ItemIndex:=0;
    ObjectType:=0;
    ObjectNumber:=CurrentPoint;
  end else
  if (bLineMode or bStreamMode) then
  Begin
    LineCountDisplay.Caption := MakeItAString(CurrentLine);
    ObjectTypeRG.ItemIndex:=1;
    ObjectType:=1;
    ObjectNumber:=CurrentLine;
  end else
  if (bPolyMode or bPolyStreamMode) then
  Begin
    LineCountDisplay.Caption := MakeItAString(CurrentArea);
    ObjectTypeRG.ItemIndex:=2;
    ObjectType:=2;
    ObjectNumber:=CurrentArea;
  end else
  if (DLGSetAttribute) then
  Begin
    LineCountDisplay.Caption := MakeItAString(CurrentDLGArea);
    ObjectTypeRG.ItemIndex:=3;
    ObjectType:=3;
    ObjectNumber:=CurrentDLGArea;
  end;
  ObjectType:=ObjectTypeRG.ItemIndex;
  ObjectNumber:=MakeItAnInteger(LineCountDisplay.Caption);
  if ({(AttriList.Count > 0)}
     ( (CurrentPoint+CurrentLine+CurrentArea+CurrentDLGArea)
        > CurrentAtt))
  then
  begin
    if (AttriList.Count = 0) then begin
     inc(CurrentAtt);
     AddAttribute;
    end else
    begin
      aAttri := AttriList.Items[AttriList.Count - 1];
      axAttri.ObjectType := aAttri^.ObjectType;
      axAttri.Count := aAttri^.Count;
      If ((axAttri.ObjectType = ObjectType) and
          (axAttri.Count <> ObjectNumber))
      then begin
        inc(CurrentAtt);
        AddAttribute;
      end;
    end;
  end;
end;





procedure TAttributesForm.AddAttribute;
Begin
  GetMajorAttribute;
  If HP020CB.Checked then
  begin
    New(aAttri);
    aAttri^.ObjectType := ObjectType;
    aAttri^.Layer := ObjectLayer;
    aAttri^.Count := ObjectNumber;
    aAttri^.Major := 20;
    aAttri^.Minor := MakeItAnInteger(HPMinor.Text);
    If (length(HPDescriptive.Text)=0) then aAttri^.Descriptive:= -1 else
        aAttri^.Descriptive:= MakeItAnInteger(HPDescriptive.Text);
    If (length(HPPMajor.Text)=0) then aAttri^.ParameterMajor:= -1 else
       aAttri^.ParameterMajor:= MakeItAnInteger(HPPMajor.Text);
    If (length(HPPMinor.Text)=0) then aAttri^.ParameterMinor:= -1 else
       aAttri^.ParameterMinor:= MakeItAnInteger(HPPMinor.Text);
    AttriList.Add(aAttri);
  end else
  If HY050CB.Checked then
  begin
    New(aAttri);
    aAttri^.ObjectType := ObjectType;
    aAttri^.Layer := ObjectLayer;
    aAttri^.Count := ObjectNumber;
    aAttri^.Major := 50;
    aAttri^.Minor := MakeItAnInteger(HYMinor.Text);
    If (length(HYDescriptive.Text)=0) then aAttri^.Descriptive:= -1 else
        aAttri^.Descriptive:= MakeItAnInteger(HYDescriptive.Text);
    If (length(HYPMajor.Text)=0) then aAttri^.ParameterMajor:= -1 else
        aAttri^.ParameterMajor:= MakeItAnInteger(HYPMajor.Text);
    If (length(HYPMinor.Text)=0) then aAttri^.ParameterMinor:= -1 else
        aAttri^.ParameterMinor:= MakeItAnInteger(HYPMinor.Text);
    AttriList.Add(aAttri);
  end else

  If SC070CB.Checked then
  begin
    New(aAttri);
    aAttri^.ObjectType := ObjectType;
    aAttri^.Layer := ObjectLayer;
    aAttri^.Count := ObjectNumber;
    aAttri^.Major := 70;
    aAttri^.Minor := MakeItAnInteger(SCMinor.Text);
    If (length(SCDescriptive.Text)=0) then aAttri^.Descriptive:= -1 else
       aAttri^.Descriptive:= MakeItAnInteger(SCDescriptive.Text);
    If (length(SCPMajor.Text)=0) then aAttri^.ParameterMajor:= -1 else
        aAttri^.ParameterMajor:= MakeItAnInteger(SCPMajor.Text);
    If (length(SCPMinor.Text)=0) then aAttri^.ParameterMinor:= -1 else
       aAttri^.ParameterMinor:= MakeItAnInteger(SCPMinor.Text);
    AttriList.Add(aAttri);
  end else

  If NV080CB.Checked then
  begin
    New(aAttri);
    aAttri^.ObjectType := ObjectType;
    aAttri^.Layer := ObjectLayer;
    aAttri^.Count := ObjectNumber;
    aAttri^.Major := 80;
    aAttri^.Minor := MakeItAnInteger(NVMinor.Text);
    If (length(NVDescriptive.Text)=0) then aAttri^.Descriptive:= -1 else
        aAttri^.Descriptive:= MakeItAnInteger(NVDescriptive.Text);
    If (length(NVPMajor.Text)=0) then aAttri^.ParameterMajor:= -1 else
        aAttri^.ParameterMajor:= MakeItAnInteger(NVPMajor.Text);
    If (length(NVPMinor.Text)=0) then aAttri^.ParameterMinor:= -1 else
        aAttri^.ParameterMinor:= MakeItAnInteger(NVPMinor.Text);
    AttriList.Add(aAttri);
  end else

  If BD090CB.Checked then
  begin
    New(aAttri);
    aAttri^.ObjectType := ObjectType;
    aAttri^.Layer := ObjectLayer;
    aAttri^.Count := ObjectNumber;
    aAttri^.Major := 90;
    aAttri^.Minor := MakeItAnInteger(BDMinor.Text);
    If (length(BDDescriptive.Text)=0) then aAttri^.Descriptive:= -1 else
      aAttri^.Descriptive:= MakeItAnInteger(BDDescriptive.Text);
    If (length(BDPMajor.Text)=0) then aAttri^.ParameterMajor:= -1 else
        aAttri^.ParameterMajor:= MakeItAnInteger(BDPMajor.Text);
    If (length(BDPMinor.Text)=0) then aAttri^.ParameterMinor:= -1 else
        aAttri^.ParameterMinor:= MakeItAnInteger(BDPMinor.Text);
    AttriList.Add(aAttri);
  end else

  If SM150CB.Checked then
  begin
    New(aAttri);
    aAttri^.ObjectType := ObjectType;
    aAttri^.Layer := ObjectLayer;
    aAttri^.Count := ObjectNumber;
    aAttri^.Major := 150;
    aAttri^.Minor := MakeItAnInteger(SMMinor.Text);
    If (length(SMDescriptive.Text)=0) then aAttri^.Descriptive:= -1 else
        aAttri^.Descriptive:= MakeItAnInteger(SMDescriptive.Text);
    If (length(SMPMajor.Text)=0) then aAttri^.ParameterMajor:= -1 else
        aAttri^.ParameterMajor:= MakeItAnInteger(SMPMajor.Text);
    If (length(SMPMinor.Text)=0) then aAttri^.ParameterMinor:= -1 else
        aAttri^.ParameterMinor:= MakeItAnInteger(SMPMinor.Text);
    AttriList.Add(aAttri);
  end else

  If RD170CB.Checked then
  begin
    New(aAttri);
    aAttri^.ObjectType := ObjectType;
    aAttri^.Layer := ObjectLayer;
    aAttri^.Count := ObjectNumber;
    aAttri^.Major := 170;
    aAttri^.Minor := MakeItAnInteger(RDMinor.Text);
    If (length(RDDescriptive.Text)=0) then aAttri^.Descriptive:= -1 else
        aAttri^.Descriptive:= MakeItAnInteger(RDDescriptive.Text);
    If (length(RDPMajor.Text)=0) then aAttri^.ParameterMajor:= -1 else
        aAttri^.ParameterMajor:= MakeItAnInteger(RDPMajor.Text);
    If (length(RDPMinor.Text)=0) then aAttri^.ParameterMinor:= -1 else
        aAttri^.ParameterMinor:= MakeItAnInteger(RDPMinor.Text);
    AttriList.Add(aAttri);
  end else

  If RR180CB.Checked then
  begin
    New(aAttri);
    aAttri^.ObjectType := ObjectType;
    aAttri^.Layer := ObjectLayer;
    aAttri^.Count := ObjectNumber;
    aAttri^.Major := 180;
    aAttri^.Minor := MakeItAnInteger(RRMinor.Text);
    If (length(RRDescriptive.Text)=0) then aAttri^.Descriptive:= -1 else
        aAttri^.Descriptive:= MakeItAnInteger(RRDescriptive.Text);
    If (length(RRPMajor.Text)=0) then aAttri^.ParameterMajor:= -1 else
        aAttri^.ParameterMajor:= MakeItAnInteger(RRPMajor.Text);
    If (length(RRPMinor.Text)=0) then aAttri^.ParameterMinor:= -1 else
        aAttri^.ParameterMinor:= MakeItAnInteger(RRPMinor.Text);
    AttriList.Add(aAttri);
  end else

  If MTS190CB.Checked then
  begin
    New(aAttri);
    aAttri^.ObjectType := ObjectType;
    aAttri^.Layer := ObjectLayer;
    aAttri^.Count := ObjectNumber;
    aAttri^.Major := 190;
    aAttri^.Minor := MakeItAnInteger(MTSMinor.Text);
    If (length(MTSDescriptive.Text)=0) then aAttri^.Descriptive:= -1 else
        aAttri^.Descriptive:= MakeItAnInteger(MTSDescriptive.Text);
    If (length(MTSPMajor.Text)=0) then aAttri^.ParameterMajor:= -1 else
        aAttri^.ParameterMajor:= MakeItAnInteger(MTSPMajor.Text);
    If (length(MTSPMinor.Text)=0) then aAttri^.ParameterMinor:= -1 else
        aAttri^.ParameterMinor:= MakeItAnInteger(MTSPMinor.Text);
    AttriList.Add(aAttri);
  end else

  If MS200CB.Checked then
  begin
    New(aAttri);
    aAttri^.ObjectType := ObjectType;
    aAttri^.Layer := ObjectLayer;
    aAttri^.Count := ObjectNumber;
    aAttri^.Major := 200;
    aAttri^.Minor := MakeItAnInteger(MSMinor.Text);
    If (length(MSDescriptive.Text)=0) then aAttri^.Descriptive:= -1 else
        aAttri^.Descriptive:= MakeItAnInteger(MSDescriptive.Text);
    If (length(MSPMajor.Text)=0) then aAttri^.ParameterMajor:= -1 else
        aAttri^.ParameterMajor:= MakeItAnInteger(MSPMajor.Text);
    If (length(MSPMinor.Text)=0) then aAttri^.ParameterMinor:= -1 else
        aAttri^.ParameterMinor:= MakeItAnInteger(MSPMinor.Text);
    AttriList.Add(aAttri);
  end else

  If PL300CB.Checked then
  begin
    New(aAttri);
    aAttri^.ObjectType := ObjectType;
    aAttri^.Layer := ObjectLayer;
    aAttri^.Count := ObjectNumber;
    aAttri^.Major := 300;
    aAttri^.Minor := MakeItAnInteger(PLMinor.Text);
    If (length(PLDescriptive.Text)=0) then aAttri^.Descriptive:= -1 else
       aAttri^.Descriptive:= MakeItAnInteger(PLDescriptive.Text);
    If (length(PLPMajor.Text)=0) then aAttri^.ParameterMajor:= -1 else
        aAttri^.ParameterMajor:= MakeItAnInteger(PLPMajor.Text);
    If (length(PLPMinor.Text)=0) then aAttri^.ParameterMinor:= -1 else
        aAttri^.ParameterMinor:= MakeItAnInteger(PLPMinor.Text);
    AttriList.Add(aAttri);
  end else

  If SPL600CB.Checked then
  begin
    New(aAttri);
    aAttri^.ObjectType := ObjectType;
    aAttri^.Layer := ObjectLayer;
    aAttri^.Count := ObjectNumber;
    aAttri^.Major := 600;
    aAttri^.Minor := MakeItAnInteger(SPLMinor.Text);
    If (length(SPLDescriptive.Text)=0) then aAttri^.Descriptive:= -1 else
        aAttri^.Descriptive:= MakeItAnInteger(SPLDescriptive.Text);
    If (length(SPLPMajor.Text)=0) then aAttri^.ParameterMajor:= -1 else
        aAttri^.ParameterMajor:= MakeItAnInteger(SPLPMajor.Text);
    If (length(SPLPMinor.Text)=0) then aAttri^.ParameterMinor:= -1 else
        aAttri^.ParameterMinor:= MakeItAnInteger(SPLPMinor.Text);
    AttriList.Add(aAttri);
  end;
End;



procedure TAttributesForm.DisplayBtnClick(Sender: TObject);
var
  HP,HY,SC,NV,BD,SM,RD,RR,MTS,MS,PL,SPL,
  Counter: Integer;
begin
  If (length(EditAttributeEdit.Text)>0) then
  begin
    val(EditAttributeEdit.Text,HP,Counter);{Pre test}
    If ((Counter = 0)and (HP >= 0))then begin
      HP:=0;HY:=0;SC:=0;NV:=0;BD:=0;
      SM:=0;RD:=0;RR:=0;MTS:=0;MS:=0;PL:=0;SPL:=0;
      GetMajorAttribute;  {set Layer}
      ObjectType:=ObjectTypeRG.ItemIndex;
      ObjectNumber:=MakeItAnInteger(EditAttributeEdit.Text);
      if (AttriList.Count > 0) then
      begin
        for Counter := (AttriList.Count - 1) downto 0 do
        begin
          aAttri := AttriList.Items[Counter];
          axAttri.ObjectType := aAttri^.ObjectType;
          axAttri.Layer := aAttri^.Layer;
          axAttri.Count := aAttri^.Count;
          If ((axAttri.Layer = ObjectLayer) and
              (axAttri.ObjectType = ObjectType) and
              (axAttri.Count = ObjectNumber))
          then
          begin
            Case aAttri^.Major of
              020:
              Begin
                HP:=1;
                HP020CB.Checked:=True;
                HPMinor.Text:=InttoStr(aAttri^.Minor);
                HPDescriptive.Text:= InttoStr(aAttri^.Descriptive);
                HPPMajor.Text:= InttoStr(aAttri^.ParameterMajor);
                HPPMinor.Text:= InttoStr(aAttri^.ParameterMinor);
              end;
              050 :
              Begin
                HY:=1;
                HY050CB.Checked:=True;
                HYMinor.Text:=InttoStr(aAttri^.Minor);
                HYDescriptive.Text:= InttoStr(aAttri^.Descriptive);
                HYPMajor.Text:= InttoStr(aAttri^.ParameterMajor);
                HYPMinor.Text:= InttoStr(aAttri^.ParameterMinor);
              end;
              070 :
              Begin
                SC:=1;
                SC070CB.Checked:=True;
                SCMinor.Text:=InttoStr(aAttri^.Minor);
                SCDescriptive.Text:= InttoStr(aAttri^.Descriptive);
                SCPMajor.Text:= InttoStr(aAttri^.ParameterMajor);
                SCPMinor.Text:= InttoStr(aAttri^.ParameterMinor);
              end;
              080 :
              Begin
                NV:=1;
                NV080CB.Checked:=True;
                NVMinor.Text:=InttoStr(aAttri^.Minor);
                NVDescriptive.Text:= InttoStr(aAttri^.Descriptive);
                NVPMajor.Text:= InttoStr(aAttri^.ParameterMajor);
                NVPMinor.Text:= InttoStr(aAttri^.ParameterMinor);
              end;
              090:
              Begin
                BD:=1;
                BD090CB.Checked:=True;
                BDMinor.Text:=InttoStr(aAttri^.Minor);
                BDDescriptive.Text:= InttoStr(aAttri^.Descriptive);
                BDPMajor.Text:= InttoStr(aAttri^.ParameterMajor);
                BDPMinor.Text:= InttoStr(aAttri^.ParameterMinor);
              end;
              150 :
              Begin
                SM:=1;
                SM150CB.Checked:=True;
                SMMinor.Text:=InttoStr(aAttri^.Minor);
                SMDescriptive.Text:= InttoStr(aAttri^.Descriptive);
                SMPMajor.Text:= InttoStr(aAttri^.ParameterMajor);
                SMPMinor.Text:= InttoStr(aAttri^.ParameterMinor);
              end;
              170 :
              Begin
                RD:=1;
                RD170CB.Checked:=True;
                RDMinor.Text:=InttoStr(aAttri^.Minor);
                RDDescriptive.Text:= InttoStr(aAttri^.Descriptive);
                RDPMajor.Text:= InttoStr(aAttri^.ParameterMajor);
                RDPMinor.Text:= InttoStr(aAttri^.ParameterMinor);
              end;
              180 :
              Begin
                RR:=1;
                RR180CB.Checked:=True;
                RRMinor.Text:=InttoStr(aAttri^.Minor);
                RRDescriptive.Text:= InttoStr(aAttri^.Descriptive);
                RRPMajor.Text:= InttoStr(aAttri^.ParameterMajor);
                RRPMinor.Text:= InttoStr(aAttri^.ParameterMinor);
              end;
              190 :
              Begin
                MTS:=1;
                MTS190CB.Checked:=True;
                MTSMinor.Text:=InttoStr(aAttri^.Minor);
                MTSDescriptive.Text:= InttoStr(aAttri^.Descriptive);
                MTSPMajor.Text:= InttoStr(aAttri^.ParameterMajor);
                MTSPMinor.Text:= InttoStr(aAttri^.ParameterMinor);
              end;
              200 :
              Begin
                MS:=1;
                MS200CB.Checked:=True;
                MSMinor.Text:=InttoStr(aAttri^.Minor);
                MSDescriptive.Text:= InttoStr(aAttri^.Descriptive);
                MSPMajor.Text:= InttoStr(aAttri^.ParameterMajor);
                MSPMinor.Text:= InttoStr(aAttri^.ParameterMinor);
              end;
              300 :
              Begin
                PL:=1;
                PL300CB.Checked:=True;
                PLMinor.Text:=InttoStr(aAttri^.Minor);
                PLDescriptive.Text:= InttoStr(aAttri^.Descriptive);
                PLPMajor.Text:= InttoStr(aAttri^.ParameterMajor);
                PLPMinor.Text:= InttoStr(aAttri^.ParameterMinor);
              end;
              600 :
              Begin
                SPL:=1;
                SPL600CB.Checked:=True;
                SPLMinor.Text:=InttoStr(aAttri^.Minor);
                SPLDescriptive.Text:= InttoStr(aAttri^.Descriptive);
                SPLPMajor.Text:= InttoStr(aAttri^.ParameterMajor);
                SPLPMinor.Text:= InttoStr(aAttri^.ParameterMinor);
              end;
            end;{case}
          end;
        end;
        {If not found then becomes unchecked}
        If HP=0 then HP020CB.Checked:= False else
        If HY=0 then HY050CB.Checked:=False else
        If SC=0 then SC070CB.Checked:=False else
        If NV=0 then NV080CB.Checked:=False else
        If BD=0 then BD090CB.Checked:=False else
        If SM=0 then SM150CB.Checked:=False else
        If RD=0 then RD170CB.Checked:=False else
        If RR=0 then RR180CB.Checked:=False else
        If MTS=0 then MTS190CB.Checked:=False else
        If MS=0 then MS200CB.Checked:=False else
        If PL=0 then PL300CB.Checked:=False else
        If SPL=0 then SPL600CB.Checked:=False else
        begin
          HP020CB.Checked:= True;
          HPMinor.Text:=InttoStr(200);
          HPDescriptive.Text:= InttoStr(-1);
          HPPMajor.Text:= InttoStr(-1);
          HPPMinor.Text:= InttoStr(-1);
        end;
      end;
    end else ShowMessage('NAN');
  end else ShowMessage('NAN');
end;


procedure TAttributesForm.EditBtnClick(Sender: TObject);
var
  {aAttriMinor,}
  ObjectLayerMajor, Counter: Integer;
begin
  ObjectType:=ObjectTypeRG.ItemIndex;
  ObjectNumber:=
    MakeItAnInteger(EditAttributeEdit.Text{LineCountDisplay.Caption});
  GetMajorAttribute;

  if (AttriList.Count > 0) then
  begin
    for Counter := (AttriList.Count - 1) downto 0 do
    begin
      aAttri := AttriList.Items[Counter];
      axAttri.Layer := aAttri^.Layer;
      axAttri.ObjectType := aAttri^.ObjectType;
      axAttri.Count := aAttri^.Count;
      If ((axAttri.ObjectType = ObjectType) and
          (axAttri.Layer = ObjectLayer) and
          (axAttri.Count = ObjectNumber))
      then
      begin
        {Replace the Atribute data from the Displayed data}
        aAttri^.ObjectType := ObjectType;
        aAttri^.Layer := ObjectLayer;
                {MakeItAnInteger(EditLayer.Text);}
        aAttri^.Count := ObjectNumber;
        If (length(EditMinor.Text)=0) then aAttri^.Minor:= -1 else
        aAttri^.Minor := MakeItAnInteger(EditMinor.Text);
        {aAttriMinor := MakeItAnInteger(EditLayer.Text);}
  Case ObjectLayer{aAttriMinor} of
  0: ObjectLayerMajor:=20;
  1: ObjectLayerMajor:=50;
  2: ObjectLayerMajor:=70;
  3: ObjectLayerMajor:=80;
  4: ObjectLayerMajor:=90;
  5: ObjectLayerMajor:=150;
  6: ObjectLayerMajor:=170;
  7: ObjectLayerMajor:=180;
  8: ObjectLayerMajor:=190;
  9: ObjectLayerMajor:=200;
  10: ObjectLayerMajor:=300;
  11: ObjectLayerMajor:=600;
  else   ObjectLayerMajor:=20;
  end;
        aAttri^.Major := ObjectLayerMajor;
        If (length(EditDescriptive.Text)=0) then aAttri^.Descriptive:= -1 else
        aAttri^.Descriptive:= MakeItAnInteger(EditDescriptive.Text);
        If (length(EditPMajor.Text)=0) then aAttri^.ParameterMajor:= -1 else
        aAttri^.ParameterMajor:= MakeItAnInteger(EditPMajor.Text);
        If (length(EditPMinor.Text)=0) then aAttri^.ParameterMinor:= -1 else
        aAttri^.ParameterMinor:= MakeItAnInteger(EditPMinor.Text);
      end;
    end;
  end;
end;


procedure TAttributesForm.SetObjectBtnClick(Sender: TObject);
var
  Counter,Counted: Integer;
begin
  ObjectType:=ObjectTypeRG.ItemIndex;
  GetMajorAttribute;
  if (AttriList.Count > 0) then
  begin
    Counted:=0;
    for Counter := (AttriList.Count - 1) downto 0 do
    begin
      aAttri := AttriList.Items[Counter];
      axAttri.Layer := aAttri^.Layer;
      axAttri.ObjectType := aAttri^.ObjectType;
      If ((axAttri.Layer = ObjectLayer) and
          (axAttri.ObjectType = ObjectType))
      then
      begin
        inc(Counted);
      end;
    end;
{    Case ObjectTypeRG.ItemIndex of
    0:If Counted< CurrentPoint then AttUpDown.Max:= Counted
     else AttUpDown.Max:= CurrentPoint;
    1:If Counted< CurrentLine then AttUpDown.Max:= Counted
     else AttUpDown.Max:= CurrentLine;
    2:If Counted< CurrentArea then AttUpDown.Max:= Counted
     else AttUpDown.Max:= CurrentArea;
    3:If Counted< CurrentDLGArea then AttUpDown.Max:= Counted
     else AttUpDown.Max:= CurrentDLGArea;
    else  AttUpDown.Max:= Counted;
    end;}
    AttUpDown.Max:= Counted;
     LineMaxCountDisplay.Caption:=Inttostr(AttUpDown.Max);
  end else
  begin
    AttUpDown.Max:= 0;
    LineMaxCountDisplay.Caption:=Inttostr(AttUpDown.Max);
  end;
end;

{THIS SHOULD NEVER be called}
procedure TAttributesForm.NewBtnClick(Sender: TObject);
begin
  GetMajorAttribute;
  ObjectType:=ObjectTypeRG.ItemIndex;
  ObjectNumber:=MakeItAnInteger(NewEdit.Text);
  if ((AttriList.Count > 0)and
      ( (CurrentPoint+CurrentLine+CurrentArea+CurrentDLGArea)
         > CurrentAtt))
  then
  begin
    inc(CurrentAtt);
    AddAttribute;
    {aAttri := AttriList.Items[AttriList.Count - 1];
    axAttri.ObjectType := aAttri^.ObjectType;
    axAttri.Layer := aAttri^.Layer;
    axAttri.Count := aAttri^.Count;
    If ((axAttri.Layer = ObjectLayer) and
        (axAttri.ObjectType = ObjectType) and
        (axAttri.Count <> ObjectNumber))
    then AddAttribute;}
  end;
end;


procedure TAttributesForm.SpeedButton1Click(Sender: TObject);
begin
  DLGCodeForm.Show;
end;

procedure TAttributesForm.SpeedButton2Click(Sender: TObject);
var Counter:Integer;
begin
  ObjectType:=ObjectTypeRG.ItemIndex;
  GetMajorAttribute;
  if (AttriList.Count > 0) then
  begin
    for Counter := (AttriList.Count - 1) downto 0 do
    begin
      aAttri := AttriList.Items[Counter];
      axAttri.Layer := aAttri^.Layer;
      axAttri.ObjectType := aAttri^.ObjectType;
      If ((axAttri.Layer = ObjectLayer) and
          (axAttri.ObjectType = ObjectType))
      then
      begin
        AttriList.Delete(Counter);
        exit;
      end;
    end;
  end;  
end;

end.
