unit DataListFrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, ComCtrls, ExtCtrls;

type
  TDataForm = class(TForm)
    InitBtn: TSpeedButton;
    LnPntLineEdit: TEdit;
    LnPntXEdit: TEdit;
    LnPntYEdit: TEdit;
    LnPntPXEdit: TEdit;
    LnPntPYEdit: TEdit;
    LnPntLayerEdit: TEdit;
    LnPntcolorEdit: TEdit;
    LnPntLineTypeEdit: TEdit;
    DataTotalLabel: TLabel;
    PointUpDown: TUpDown;
    PointCurrentEdit: TEdit;
    GetObjectBtn: TSpeedButton;
    HelpBtn: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    ObjectEdit: TEdit;
    ObjectUpDown: TUpDown;
    ObjectTypeRG: TRadioGroup;
    GetPointBtn: TSpeedButton;
    PolyBrushcolorEdit: TEdit;
    FillColorLabel: TLabel;
    SetObjectBtn: TSpeedButton;
    procedure InitBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure GetObjectBtnClick(Sender: TObject);
    procedure GetPointBtnClick(Sender: TObject);
    procedure SetObjectBtnClick(Sender: TObject);
  private
    { Private declarations }
    Initialized:Boolean;
  public
    { Public declarations }
  end;

var
  DataForm: TDataForm;

implementation

{$R *.DFM}

uses DGlobalsUnit, DigitizerMain, DAttributesForm;

procedure TDataForm.FormCreate(Sender: TObject);
begin
  left := DataFormX;
  top := DataFormY;
  Initialized:=False;
end;

procedure TDataForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DataFormX := DataForm.left;
  DataFormY := DataForm.top;
  DoSaver;
end;

procedure TDataForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(7000);
end;

{ObjectTypeRG.Itemindex}
{Need to Search through and find the NUMBER of Objects}
procedure TDataForm.InitBtnClick(Sender: TObject);
var
Counter,
DataCurrentLine:integer;
begin
  Case ObjectTypeRG.Itemindex of
  0:begin
      if (CurrentPoint > 0 ) then
      begin
        LnPntLineEdit.Visible:=False;
        {Label1.Caption:= 'Line #';}
        FillColorLabel.Visible:=False;
        PolyBrushcolorEdit.Visible:=False;
        Label1.Visible:=False;
        LnPntLineTypeEdit.Visible:=True;
        Label8.Visible:=True;
        Label8.Caption:= 'Point Type';{Line Type}
        DataCurrentLine:=PointList.Count - 1;
        DataTotalLabel.Caption:= Inttostr(DataCurrentLine);
        ObjectUpDown.Max:= 0;
        ObjectUpDown.Position:=0;
        PointUpDown.Position:=0;
        PointUpDown.Max:=DataCurrentLine;
        Initialized:=False;{Only after Object selected}
        Application.ProcessMessages;
        GetObjectBtnClick(Sender);
      end;
    End;
  1:Begin
      if (CurrentLine > 0 ) then
      begin
        FillColorLabel.Visible:=False;
        PolyBrushcolorEdit.Visible:=False;
        LnPntLineEdit.Visible:=True;
        Label1.Visible:=True;
        Label1.Caption:= 'Line #';
        LnPntLineTypeEdit.Visible:=True;
        Label8.Visible:=True;
        Label8.Caption:= 'Line Type';{Line Type}
        DataCurrentLine:=0;
        for Counter := 0 to (LineList.Count - 1) do
        begin
          asDrawingLnPnt := LineList.Items[Counter];
          if (asDrawingLnPnt^.Line <> DataCurrentLine) then
             inc(DataCurrentLine);
        end;
        DataTotalLabel.Caption:= Inttostr(DataCurrentLine);
        ObjectUpDown.Max:= (DataCurrentLine{ - 1});
        ObjectUpDown.Position:=0;
        PointUpDown.Position:=0;
        PointUpDown.Max:=0;
        Initialized:=False;{Only after Object selected}
        Application.ProcessMessages;
        GetObjectBtnClick(Sender);
      end;
    End;
  2:Begin
      if (CurrentArea > 0 ) then
      begin
        FillColorLabel.Visible:=True;
        PolyBrushcolorEdit.Visible:=True;
        LnPntLineEdit.Visible:=True;
        Label1.Visible:=True;
        Label1.Caption:= 'Area #';
        LnPntLineTypeEdit.Visible:=True;
        Label8.Visible:=True;
        Label8.Caption:= 'Poly Type';{Line Type}
        DataCurrentLine:=0;
        for Counter := 0 to (AreaList.Count - 1) do
        begin
          asDrawingAreaPnt := AreaList.Items[Counter];
          if (asDrawingAreaPnt^.Area <> DataCurrentLine) then
             inc(DataCurrentLine);
        end;
        DataTotalLabel.Caption:= Inttostr(DataCurrentLine);
        ObjectUpDown.Max:= (DataCurrentLine{ - 1});
        ObjectUpDown.Position:=0;
        PointUpDown.Position:=0;
        PointUpDown.Max:=0;
        Initialized:=False;{Only after Object selected}
        Application.ProcessMessages;
        GetObjectBtnClick(Sender);
      end;
    End;
  end;{Case}
end;

{Need to Search through and find the OBJECT NUMBER of Points}
procedure TDataForm.GetObjectBtnClick(Sender: TObject);
var
Counter, WhichPoint, WhichObject:Integer;
begin
  WhichObject:=ObjectUpDown.Position;
  Case ObjectTypeRG.Itemindex of
  0:Begin
      if (CurrentPoint > 0 ) then
      begin
        Initialized:=True;
        Application.ProcessMessages;
        GetPointBtnClick(Sender);
      end;
    End;
  1:Begin
      if (CurrentLine > 0 ) then
      begin
        WhichPoint:=0;
        for Counter := 0 to (LineList.Count - 1) do
        begin
          asDrawingLnPnt := LineList.Items[Counter];
          if (asDrawingLnPnt^.Line = WhichObject) then
          inc(WhichPoint);
        end;
        PointUpDown.Position:=1;
        PointUpDown.Max:=WhichPoint;
        Initialized:=True;
        Application.ProcessMessages;
        GetPointBtnClick(Sender);
      end;
    End;
  2:Begin
      if (CurrentArea > 0 ) then
      begin
        WhichPoint:=0;
        for Counter := 0 to (AreaList.Count - 1) do
        begin
          asDrawingAreaPnt := AreaList.Items[Counter];
          if (asDrawingAreaPnt^.Area = WhichObject) then
          inc(WhichPoint);
        end;
        PointUpDown.Position:=1;
        PointUpDown.Max:=WhichPoint;
        Initialized:=True;
        Application.ProcessMessages;
        GetPointBtnClick(Sender);
      end;
    End;
  end;{Case}
end;


{Select an Object and display only ITS points}
procedure TDataForm.GetPointBtnClick(Sender: TObject);
var
  Counter,
  WhichPointCount, WhichObjectCount,
  WhichPoint, WhichObject:Integer;
begin
  if Initialized then begin
  WhichObject:=ObjectUpDown.Position;
  WhichPoint:=PointUpDown.Position;
  Case ObjectTypeRG.Itemindex of
  0:Begin
      asDrawingPnt := PointList.Items[WhichPoint];
      begin
        axDrawingPnt.X := asDrawingPnt^.X;
        LnPntXEdit.Text:= Inttostr(axDrawingPnt.X);
        axDrawingPnt.Y := asDrawingPnt^.Y;
        LnPntYEdit.Text:= Inttostr(axDrawingPnt.Y);
        axDrawingPnt.PX := asDrawingPnt^.PX;
        LnPntPXEdit.Text:= Inttostr(axDrawingPnt.PX);
        axDrawingPnt.PY := asDrawingPnt^.PY;
        LnPntPYEdit.Text:= Inttostr(axDrawingPnt.PY);
        axDrawingPnt.Layer := asDrawingPnt^.Layer;
        LnPntLayerEdit.Text:= Inttostr(axDrawingPnt.Layer);
        axDrawingPnt.color := asDrawingPnt^.color;
        LnPntcolorEdit.Text:= Inttostr(axDrawingPnt.color);
        axDrawingPnt.PointType := asDrawingPnt^.PointType;
        LnPntLineTypeEdit.Text:= Inttostr(axDrawingPnt.PointType);
      end;
    end;
  1:Begin
      WhichObjectCount :=0;
      for Counter := 0 to (LineList.Count - 1) do
      begin
        asDrawingLnPnt := LineList.Items[Counter];
        if (asDrawingLnPnt^.Line < WhichObject) then
          inc(WhichObjectCount);
      end;
      WhichPointCount:= WhichObjectCount+WhichPoint;
      asDrawingLnPnt := LineList.Items[WhichPointCount];
      begin
        axDrawingLnPnt.Line := asDrawingLnPnt^.Line;
        LnPntLineEdit.Text:= Inttostr(axDrawingLnPnt.Line);
        axDrawingLnPnt.X := asDrawingLnPnt^.X;
        LnPntXEdit.Text:= Inttostr(axDrawingLnPnt.X);
        axDrawingLnPnt.Y := asDrawingLnPnt^.Y;
        LnPntYEdit.Text:= Inttostr(axDrawingLnPnt.Y);
        axDrawingLnPnt.PX := asDrawingLnPnt^.PX;
        LnPntPXEdit.Text:= Inttostr(axDrawingLnPnt.PX);
        axDrawingLnPnt.PY := asDrawingLnPnt^.PY;
        LnPntPYEdit.Text:= Inttostr(axDrawingLnPnt.PY);
        axDrawingLnPnt.Layer := asDrawingLnPnt^.Layer;
        LnPntLayerEdit.Text:= Inttostr(axDrawingLnPnt.Layer);
        axDrawingLnPnt.color := asDrawingLnPnt^.color;
        LnPntcolorEdit.Text:= Inttostr(axDrawingLnPnt.color);
        axDrawingLnPnt.LineType := asDrawingLnPnt^.LineType;
        LnPntLineTypeEdit.Text:= Inttostr(axDrawingLnPnt.LineType);
        {CurrentLine := axDrawingLnPnt.Line;
        axDrawingLnPnt.PX := (Round(axDrawingLnPnt.X * RX));
        axDrawingLnPnt.PY := (ScreenHeight - (Round(axDrawingLnPnt.Y
          * RY)));}
      end;
    end;
  2:Begin
      WhichObjectCount :=0;
      for Counter := 0 to (AreaList.Count - 1) do
      begin
        asDrawingAreaPnt := AreaList.Items[Counter];
        if (asDrawingAreaPnt^.Area < WhichObject) then
          inc(WhichObjectCount);
      end;
      WhichPointCount:= WhichObjectCount+WhichPoint;
      asDrawingAreaPnt := AreaList.Items[WhichPointCount];
      begin
        axDrawingAreaPnt.Area := asDrawingAreaPnt^.Area;
        LnPntLineEdit.Text:= Inttostr(axDrawingAreaPnt.Area);
        axDrawingAreaPnt.X := asDrawingAreaPnt^.X;
        LnPntXEdit.Text:= Inttostr(axDrawingAreaPnt.X);
        axDrawingAreaPnt.Y := asDrawingAreaPnt^.Y;
        LnPntYEdit.Text:= Inttostr(axDrawingAreaPnt.Y);
        axDrawingAreaPnt.PX := asDrawingAreaPnt^.PX;
        LnPntPXEdit.Text:= Inttostr(axDrawingAreaPnt.PX);
        axDrawingAreaPnt.PY := asDrawingAreaPnt^.PY;
        LnPntPYEdit.Text:= Inttostr(axDrawingAreaPnt.PY);
        axDrawingAreaPnt.Layer := asDrawingAreaPnt^.Layer;
        LnPntLayerEdit.Text:= Inttostr(axDrawingAreaPnt.Layer);
        axDrawingAreaPnt.Pencolor := asDrawingAreaPnt^.Pencolor;
        LnPntcolorEdit.Text:= Inttostr(axDrawingAreaPnt.Pencolor);
        axDrawingAreaPnt.Brushcolor := asDrawingAreaPnt^.Brushcolor;
        PolyBrushcolorEdit.Text:= Inttostr(axDrawingAreaPnt.Brushcolor);
        axDrawingAreaPnt.PolyType := asDrawingAreaPnt^.PolyType;
        LnPntLineTypeEdit.Text:= Inttostr(axDrawingAreaPnt.PolyType);
      end;
    end;
  end;{Case}
  end;
end;

{Change the ...Layer, Color, Line Type, Fill Type, Fill Color
 for ALL POINTs of THAT Object }
procedure TDataForm.SetObjectBtnClick(Sender: TObject);
var
  ObjectLayerMajor,  Counter, ObjectType,
  InLayerStorage, OutLayerStorage,
  WhichPoint, WhichObject:Integer;
begin
  if Initialized then begin
  WhichObject:=ObjectUpDown.Position;
  WhichPoint:=PointUpDown.Position;
  ObjectType:= ObjectTypeRG.Itemindex;
  InLayerStorage:=0;
  OutLayerStorage:=0;
  Case ObjectType of
  0:Begin
      asDrawingPnt := PointList.Items[WhichPoint];
      begin
        WhichObject:= WhichPoint;{for att use}
        axDrawingPnt.X := asDrawingPnt^.X;
        axDrawingPnt.Y := asDrawingPnt^.Y;
        axDrawingPnt.PX := asDrawingPnt^.PX;
        axDrawingPnt.PY := asDrawingPnt^.PY;
        axDrawingPnt.Layer := asDrawingPnt^.Layer;
        axDrawingPnt.color := asDrawingPnt^.color;
        axDrawingPnt.PointType := asDrawingPnt^.PointType;
        InLayerStorage:= axDrawingPnt.Layer;
        asDrawingPnt^.X := axDrawingPnt.X;
        asDrawingPnt^.Y := axDrawingPnt.Y;
        asDrawingPnt^.PX := axDrawingPnt.PX;
        asDrawingPnt^.PY := axDrawingPnt.PY;
        axDrawingPnt.Layer := MakeItAnInteger(LnPntLayerEdit.Text);
        asDrawingPnt^.Layer := axDrawingPnt.Layer;
        OutLayerStorage:= axDrawingPnt.Layer;
        axDrawingPnt.color := MakeItAnInteger(LnPntcolorEdit.Text);
        asDrawingPnt^.color := axDrawingPnt.color;
        axDrawingPnt.PointType := MakeItAnInteger(LnPntLineTypeEdit.Text);
        asDrawingPnt^.PointType := axDrawingPnt.PointType;
      end;
    end;
  1:Begin
      for Counter := 0 to (LineList.Count - 1) do
      begin
        asDrawingLnPnt := LineList.Items[Counter];
        if (asDrawingLnPnt^.Line = WhichObject) then
      begin
        axDrawingLnPnt.Line := asDrawingLnPnt^.Line;
        axDrawingLnPnt.X := asDrawingLnPnt^.X;
        axDrawingLnPnt.Y := asDrawingLnPnt^.Y;
        axDrawingLnPnt.PX := asDrawingLnPnt^.PX;
        axDrawingLnPnt.PY := asDrawingLnPnt^.PY;
        axDrawingLnPnt.Layer := asDrawingLnPnt^.Layer;
        axDrawingLnPnt.color := asDrawingLnPnt^.color;
        axDrawingLnPnt.LineType := asDrawingLnPnt^.LineType;
        {Get the Max line # in Layer to ADD new line to...???}
        InLayerStorage:= axDrawingPnt.Layer;
        asDrawingLnPnt^.Line := axDrawingLnPnt.Line;
        asDrawingLnPnt^.X := axDrawingLnPnt.X;
        asDrawingLnPnt^.Y := axDrawingLnPnt.Y;
        asDrawingLnPnt^.PX := axDrawingLnPnt.PX;
        asDrawingLnPnt^.PY := axDrawingLnPnt.PY;
        axDrawingLnPnt.Layer :=MakeItAnInteger(LnPntLayerEdit.Text);
        asDrawingLnPnt^.Layer := axDrawingLnPnt.Layer;
        OutLayerStorage:= axDrawingPnt.Layer;
        axDrawingLnPnt.color := MakeItAnInteger(LnPntcolorEdit.Text);
        asDrawingLnPnt^.color := axDrawingLnPnt.color;
        axDrawingLnPnt.LineType := MakeItAnInteger(LnPntLineTypeEdit.Text);
        asDrawingLnPnt^.LineType := axDrawingLnPnt.LineType;
      end;end;
    end;
  2:Begin
      for Counter := 0 to (AreaList.Count - 1) do
      begin
        asDrawingAreaPnt := AreaList.Items[Counter];
        if (asDrawingAreaPnt^.Area = WhichObject) then
      begin
        axDrawingAreaPnt.Area := asDrawingAreaPnt^.Area;
        axDrawingAreaPnt.X := asDrawingAreaPnt^.X;
        axDrawingAreaPnt.Y := asDrawingAreaPnt^.Y;
        axDrawingAreaPnt.PX := asDrawingAreaPnt^.PX;
        axDrawingAreaPnt.PY := asDrawingAreaPnt^.PY;
        axDrawingAreaPnt.Layer := asDrawingAreaPnt^.Layer;
        axDrawingAreaPnt.Pencolor := asDrawingAreaPnt^.Pencolor;
        axDrawingAreaPnt.Brushcolor := asDrawingAreaPnt^.Brushcolor;
        axDrawingAreaPnt.PolyType := asDrawingAreaPnt^.PolyType;
        InLayerStorage:= axDrawingPnt.Layer;
        asDrawingAreaPnt^.Area := axDrawingAreaPnt.Area;
        asDrawingAreaPnt^.X := axDrawingAreaPnt.X;
        asDrawingAreaPnt^.Y := axDrawingAreaPnt.Y;
        asDrawingAreaPnt^.PX := axDrawingAreaPnt.PX;
        asDrawingAreaPnt^.PY := axDrawingAreaPnt.PY;
        axDrawingAreaPnt.Layer :=MakeItAnInteger(LnPntLayerEdit.Text);
        asDrawingAreaPnt^.Layer := axDrawingAreaPnt.Layer;
        OutLayerStorage:= axDrawingPnt.Layer;
        axDrawingAreaPnt.Pencolor := MakeItAnInteger(LnPntcolorEdit.Text);
        asDrawingAreaPnt^.Pencolor := axDrawingAreaPnt.Pencolor;
        axDrawingAreaPnt.Brushcolor := MakeItAnInteger(PolyBrushcolorEdit.Text);
        asDrawingAreaPnt^.Brushcolor := axDrawingAreaPnt.Brushcolor;
        axDrawingAreaPnt.PolyType := MakeItAnInteger(LnPntLineTypeEdit.Text);
        asDrawingAreaPnt^.PolyType := axDrawingAreaPnt.PolyType;
      end;end;
    end;
  end;{Case}
  {Change Attribute ObjectType WhichObject InLayerStorage, OutLayerStorage,}
  if (AttriList.Count > 0) then
  begin
    for Counter := (AttriList.Count - 1) downto 0 do
    begin
      aAttri := AttriList.Items[Counter];
      axAttri.Layer := aAttri^.Layer;
      axAttri.ObjectType := aAttri^.ObjectType;
      axAttri.Count := aAttri^.Count;
      If ((axAttri.ObjectType = ObjectType) and
          (axAttri.Layer = InLayerStorage) and
          (axAttri.Count = WhichObject))
      then
      begin
        {Replace the Atribute data from the Displayed data}
        aAttri^.ObjectType := ObjectType;
        aAttri^.Layer := OutLayerStorage;
        aAttri^.Count := WhichObject;
        aAttri^.Minor := aAttri^.Minor;
  Case OutLayerStorage of
  0: ObjectLayerMajor:=20;
  1: ObjectLayerMajor:=50;
  2: ObjectLayerMajor:=70;
  3: ObjectLayerMajor:=80;
  4: ObjectLayerMajor:=90;
  5: ObjectLayerMajor:=150;
  6: ObjectLayerMajor:=170;
  7: ObjectLayerMajor:=180;
  8: ObjectLayerMajor:=190;
  9: ObjectLayerMajor:=200;
  10: ObjectLayerMajor:=300;
  11: ObjectLayerMajor:=600;
  else   ObjectLayerMajor:=20;
  end;
        aAttri^.Major := ObjectLayerMajor;
        aAttri^.Descriptive:= aAttri^.Descriptive;
        aAttri^.ParameterMajor:= aAttri^.ParameterMajor;
        aAttri^.ParameterMinor:=  aAttri^.ParameterMinor;
      end;
    end;
  end;
  end;
end;

end.
