{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit buzGCTP;
{Combines GCTP Forward, Inverse  sphdz, untfz}
{Input as xxxdxxMxxS.. Convert to ____
Whatever DD? for Radians
Stored as DLG coordinate
Init figures out the stuff
and "returns" ? the xxx____ number for conversion
xxxInv or xxxFor requires other than x y lon lat ????}
interface

uses buzGlobal;

{InitLLtoXYout mapping lat,long to x,y}
procedure InitLLtoXYout;
{ForInit(outsys, outzone, outdatum: Integer;
                  var outparm: parameters;
                  var iflg,for_trans: Integer);}
procedure DoLLtoXY(
{ForCoords(for_trans: Integer;}
                    LongXCoord, LatYCoord:Double;
                    var XCoord, YCoord:Double);


{mapping x,y to lat,long }
(* PURPOSE:  Initializes inverse projection transformation parameters
void inv_init(long int insys, long int inzone,
          double *inparm, long int indatum,
         char *fn27, char *fn83,
         long int *iflg, InverseTransFunc inv_trans[]);*)
procedure InitXYtoLLin;
{InvInit(insys, inzone, indatum: Integer;
                    var inparm: parameters;
                    var iflg,inv_trans: Integer);}

procedure DoXYtoLL(
{InvCoords(inv_trans: Integer;}
                    XCoord, YCoord:Double;
                    var LongXCoord, LatYCoord:Double);
(*    function assigns values to the semimajor axis, semiminor
int sphdz(long int isph, double *parm,
double *r_major, double *r_minor, double *radius);*)
{function}
procedure Spheroidz(isph: Integer;
                    var parm: parameters;
                    var r_major, r_minor, radius: double){: Integer};
(*long untfz(long int inunit, long int outunit, double *factor); *)
function Untfz(inunit, outunit: Integer; var factor: double):  Integer;

procedure SetupPathName(inbuzMessageX,inbuzMessageY:Integer;
                        inbuzProjectPath, inbuzProjectName:String);

implementation
uses
  buzAlber, buzAlcon, buzAzim, buzEqcon, buzEqui, buzGnom, buzGood,
  buzGvnsp, buzHam, buzImolw, buzLamaz, buzLamcc, buzMer, buzMill,
  buzMolw,  buzObleq, buzOmer, buzOrth, buzPoly, buzPs, buzRob,
  buzSin, buzSom, buzSter, buzStpl, buzTm, buzVandg, buzWiv, buzWvii;

procedure SetupPathName(inbuzMessageX,inbuzMessageY:Integer;
                        inbuzProjectPath, inbuzProjectName:String);
Begin
  buzMessageX:=inbuzMessageX;
  buzMessageX:=inbuzMessageY;
  buzProjectPath:=inbuzProjectPath;
  buzProjectName:=inbuzProjectName;
End;

//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
{void for_init(
long int outsys,     /* output system code       */
long int outzone,    /* output zone number				*/
double *outparm,     /* output array of projection parameters	*/
long int outdatum,   /* output datum					*/
char *fn27,	/* NAD 1927 parameter file			*/
char *fn83,	/* NAD 1983 parameter file			*/
long int *iflg,	/* status flag					*/
ForwardTransFunc for_trans[])   	/* forward function pointer}
{Procedure  ForInit(outsys,outzone,outdatum,iflg:Integer);}

procedure InitLLtoXYout;
{ ForInit(outsys, outzone, outdatum: Integer;
                  var outparm: parameters;
                  var iflg, for_trans: Integer);}
var
outsys, outzone, outdatum: Integer;
  zone: Integer; //* zone number
    azimuth, //* azimuth
    alf, //* SOM angle
    angle, //* rotation anlge
    lon1, //* longitude point in utm scene
    lon2, //* 2nd longitude
    lat1, //* 1st standard parallel
    lat2, //* 2nd standard parallel
    center_long, //* center longitude
    center_lat, //* center latitude
    h, //* height above sphere
    lon_origin, //* longitude at origin
    lat_origin, //* latitude at origin
    r_major, //* major axis in meters
    r_minor, //* minor axis in meters
    scale_factor, //* scale factor
    false_easting, //* false easting in meters
    false_northing, //* false northing in meters
    time, //* SOM time
    radius, //* radius of sphere
    shape_m, //* constant used for Oblated Equal Area
    shape_n: double; //* constant used for Oblated Equal Area
    start: Integer; //* where SOM starts beginning or end
     {double paksz(double ang, long int *iflg);
       /* function to convert DMS to DEGz}
    tmpdatum, //* temporary datum for UTM			*/
    path, //* SOM path number				*/
    satnum, //* SOM satellite number				*/
    mode: Integer; //* which initialization method  to use A or B	*/
begin
//* Initialize forward transformations
outsys:=Round(Outparm[15]);
outdatum:=Round(Outparm[18]);
If Outparm[15]=2 then  outzone:= Round(Outparm[20])
   else outzone:= Round(Outparm[17]);
//* find the correct major and minor axis
  spheroidz(outdatum, outparm, r_major, r_minor, radius);
(*Function Spheroidz(isph:Integer; var {parm,}
  r_major, r_minor, radius:double):Integer;*)
  false_easting := outparm[6];
  false_northing := outparm[7];

  if (outsys = UTM) then
  begin
    //* this is the call to initialize U T M
     //* set Clarke 1866 spheroid if negative datum code
    if (outdatum < 0) then
    begin
      tmpdatum := 0;
(*  spheroidz(outdatum,{outparm,}r_major,r_minor,radius);*)
      spheroidz(tmpdatum, outparm, r_major, r_minor, radius);
    end;
    zone := outzone;
    if (zone = 0) then
    begin
      lon1 := paksz(outparm[0], iflg) * 3600 * S2R;
      if (iflg <> 0) then exit; { return;}
      lat1 := paksz(outparm[1], iflg) * 3600 * S2R;
      if (iflg <> 0) then exit; {return;}
      zone := CalcUtmZone(lon1 * R2D);
      if (lat1 < 0) then zone := -zone;
    end;
    scale_factor := 0.9996;
    iflg := utmforint(r_major, r_minor, scale_factor, zone);
    for_trans := outsys;{utmfor;}
  end
  else if (outsys = SPCS) then
  begin
    //* this is the call to initialize STATE PLANE
    iflg := stplnforint(outzone, outdatum {,fn27,fn83});
    if (iflg <> 0) then exit; {return;}
    for_trans := outsys;
  end
  else
    if (outsys = ALBERS) then
    begin
    //* this is the call to initialize ALBERS CONICAL EQUAL AREA
      lat1 := paksz(outparm[2], iflg) * 3600 * S2R;
      if (iflg <> 0) then exit; {       return;}
      lat2 := paksz(outparm[3], iflg) * 3600 * S2R;
      if (iflg <> 0) then exit; {       return;}
      lat_origin := paksz(outparm[5], iflg) * 3600 * S2R;
      if (iflg <> 0) then exit; {       return;}
      center_long := paksz(outparm[4], iflg) * 3600 * S2R;
      if (iflg <> 0) then exit; {       return;}
      iflg := alberforint(r_major, r_minor, lat1, lat2, center_long,
        lat_origin,
        false_easting, false_northing);
      for_trans := outsys;
    end
    else
      if (outsys = LAMCC) then
      begin
    //* this is the call to initialize LAMBERT CONFORMAL CONIC
        lat1 := paksz(outparm[2], iflg) * 3600 * S2R;
        if (iflg <> 0) then exit; {       return;}
        lat2 := paksz(outparm[3], iflg) * 3600 * S2R;
        if (iflg <> 0) then exit; {       return;}
        center_long := paksz(outparm[4], iflg) * 3600 * S2R;
        if (iflg <> 0) then exit; {       return;}
        lat_origin := paksz(outparm[5], iflg) * 3600 * S2R;
        if (iflg <> 0) then exit; {       return;}
        iflg := lamccforint(r_major, r_minor, lat1, lat2,
          center_long, lat_origin,
          false_easting, false_northing);
        for_trans := outsys;
      end
      else
        if (outsys = MERCAT) then
        begin
    //* this is the call to initialize MERCATOR
          center_long := paksz(outparm[4], iflg) * 3600 * S2R;
          if (iflg <> 0) then exit; {       return;}
          lat1 := paksz(outparm[5], iflg) * 3600 * S2R;
          if (iflg <> 0) then exit; {       return;}
          iflg := merforint(r_major, r_minor, center_long, lat1,
            false_easting,
            false_northing);
        for_trans := outsys;
        end
        else
          if (outsys = PS) then
          begin
    //* this is the call to initialize POLAR STEREOGRAPHIC
            center_long := paksz(outparm[4], iflg) * 3600 * S2R;
            if (iflg <> 0) then exit; {       return;}
            lat1 := paksz(outparm[5], iflg) * 3600 * S2R;
            if (iflg <> 0) then exit; {       return;}
            iflg := psforint(r_major, r_minor, center_long, lat1,
              false_easting,
              false_northing);
        for_trans := outsys;
          end
          else
            if (outsys = POLYC) then
            begin
    //* this is the call to initialize POLYCONIC
              center_long := paksz(outparm[4], iflg) * 3600 * S2R;
              if (iflg <> 0) then exit; {       return;}
              lat_origin := paksz(outparm[5], iflg) * 3600 * S2R;
              if (iflg <> 0) then exit; {       return;}
              iflg := polyforint(r_major, r_minor, center_long,
                lat_origin, false_easting,
                false_northing);
        for_trans := outsys;
            end
            else
              if (outsys = EQUIDC) then
              begin
    //* this is the call to initialize EQUIDISTANT CONIC
                lat1 := paksz(outparm[2], iflg) * 3600 * S2R;
                if (iflg <> 0) then exit; {       return;}
                lat2 := paksz(outparm[3], iflg) * 3600 * S2R;
                if (iflg <> 0) then exit; {       return;}
                center_long := paksz(outparm[4], iflg) * 3600 * S2R;
                if (iflg <> 0) then exit; {       return;}
                lat_origin := paksz(outparm[5], iflg) * 3600 * S2R;
                if (iflg <> 0) then exit; {       return;}
                if (outparm[8] = 0) then mode := 0
                else mode := 1;
                iflg := eqconforint(r_major, r_minor, lat1, lat2,
                  center_long, lat_origin,
                  false_easting, false_northing, mode);
        for_trans := outsys;
              end
else if (outsys = TM) then
begin
    //* this is the call to initialize TRANSVERSE MECTAR
    scale_factor := outparm[2];
    center_long := paksz(outparm[4], iflg) * 3600 *S2R;
    if (iflg <> 0) then exit; {       return;}
    lat_origin := paksz(outparm[5], iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := tmforint(r_major, r_minor, scale_factor,
    center_long, lat_origin,
    false_easting, false_northing);
        for_trans := outsys;
    end
    else if (outsys = STEREO) then
    begin
    //* this is the call to initialize STEREOGRAPHIC
    center_long := paksz(outparm[4], iflg) * 3600 *S2R;
    if (iflg <> 0) then exit; {       return;}
    center_lat := paksz(outparm[5], iflg) * 3600 *S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := sterforint(radius, center_long,
    center_lat, false_easting,
    false_northing);
        for_trans := outsys;
    end else
    if (outsys = LAMAZ) then
    begin
    center_long := 0;
    //* this is the call to initialize LAMBERT AZIMUTHAL
    if (iflg <> 0) then exit; {       return;}
    center_lat := paksz(outparm[5], iflg) * 3600 *S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := lamazforint(radius, center_long,
              center_lat, false_easting,
              false_northing);
        for_trans := outsys;
    end else
    if (outsys = AZMEQD) then
    begin
    //* this is the call to initialize AZIMUTHAL EQUIDISTANT
    center_long := paksz(outparm[4], iflg) * 3600* S2R;
    if (iflg <> 0) then exit; {       return;}
    center_lat := paksz(outparm[5], iflg) * 3600* S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := azimforint(radius, center_long,
                          center_lat, false_easting,
                          false_northing);
        for_trans := outsys;
    end else
    if (outsys = GNOMON) then
    begin
    //* this is the call to initialize GNOMONIC
    center_long := paksz(outparm[4], iflg) *3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    center_lat := paksz(outparm[5], iflg) * 3600* S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := gnomforint(radius, center_long,
                      center_lat,
                      false_easting,
                      false_northing);
        for_trans := outsys;
    end else
    if (outsys = ORTHO) then
    begin
    //* this is the call to initalize ORTHOGRAPHIC
    center_long := paksz(outparm[4], iflg) *3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    center_lat := paksz(outparm[5], iflg) *3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := orthforint(radius, center_long,
                        center_lat,
                        false_easting,
                        false_northing);
        for_trans := outsys;
    end else
    if (outsys = GVNSP) then
    begin
    // this is the call to initalize
    // GENERAL VERTICAL NEAR-SIDE PERSPECTIVE
    center_long := paksz(outparm[4], iflg)* 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    center_lat := paksz(outparm[5], iflg) *3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    h := outparm[2];
    iflg := gvnspforint(radius, h,
                        center_long,
                        center_lat,
                        false_easting,
                        false_northing);
        for_trans := outsys;
    end else
    if (outsys = SNSOID) then
    begin
    //* this is the call to initialize SINUSOIDAL
    center_long := paksz(outparm[4], iflg)* 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := sinforint(radius,
                      center_long,
                      false_easting,
                      false_northing);
        for_trans := outsys;
    end else
    if (outsys = EQRECT) then
    begin
    //* this is the call to initialize EQUIRECTANGULAR
    center_long := paksz(outparm[4],iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    lat1 := paksz(outparm[5], iflg) *3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := equiforint(radius,
                       center_long,
                       lat1,
                       false_easting,
                       false_northing);
        for_trans := outsys;
    end else
    if (outsys = MILLER) then
    begin
    //* this is the call to initialize MILLER CYLINDRICAL
    center_long := paksz(outparm[4],iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := millforint(radius,
                      center_long,
                      false_easting,
                      false_northing);
        for_trans := outsys;
    end else
    if (outsys = VGRINT) then
    begin
    //* this is the call to initialize VAN DER GRINTEN
    center_long :=paksz(outparm[4], iflg) * 3600* S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := vandgforint(radius,
                        center_long,
                        false_easting,
                        false_northing);
        for_trans := outsys;
    end
    else
    if (outsys = HOM) then
    begin {UzHom}
    lat1 := 0;
    lat2 := 0;
    lon1 := 0;
    lon2 := 0;
    azimuth := 0;
    lon_origin := 0;
     //* this is the call to initialize HOTLINE OBLIQUE MERCATOR
     scale_factor := outparm[2];
     lat_origin :=
     paksz(outparm[5], iflg) * 3600* S2R;
     if (iflg <> 0) then exit; {       return;}
     if (outparm[12] <> 0) then
     begin
     mode := 1;
     azimuth :=
     paksz(outparm[3], iflg) *3600 * S2R;
     if (iflg <> 0) then exit; {       return;}
     lon_origin :=paksz(outparm[4], iflg) *3600 * S2R;
     if (iflg <> 0) then exit; {       return;}
     end
     else
     begin
     mode := 0;
     lon1 := paksz(outparm[8],iflg) * 3600 * S2R;
     if (iflg <> 0) then exit; {       return;}
     lat1 := paksz(outparm[9],iflg) * 3600 * S2R;
     if (iflg <> 0) then exit; {       return;}
     lon2 := paksz(outparm[10],iflg) * 3600 * S2R;
     if (iflg <> 0) then exit; {       return;}
     lat2 := paksz(outparm[11],iflg) * 3600 * S2R;
     if (iflg <> 0) then exit; {       return;}
     end; {UzHom}
     iflg := omerforint(r_major,
     r_minor, scale_factor,
     azimuth, lon_origin,
     lat_origin, false_easting,
     false_northing, lon1, lat1,
     lon2, lat2, mode);
        for_trans := outsys;
                                          { omerfor;}
     end else
     if (outsys = SOM) then
     begin
     alf := 0; lon1 := 0; time:= 0; start := 0;
    //* this is the call to initialize SOM
    path := Round(outparm[3]);
    satnum :=Round(outparm[2]);
    if (outparm[12] = 0) then
    begin
    mode := 1;
    alf := paksz(outparm[3],iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    lon1 := paksz(outparm[4],iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    time := outparm[8];
    start :=Round(outparm[10]);
    end
    else mode := 0;
// iflg = somforint(r_major,r_minor,satnum,path,
//                  false_easting,false_northing);
    iflg := somforint(r_major,
    r_minor, satnum, path, alf,
    lon1, false_easting,
    false_northing, time,start, mode);
        for_trans := outsys;
    { somfor;}
    end
    else
    if (outsys = HAMMER) then
    begin
    //* this is the call to initialize HAMMER
    center_long :=paksz(outparm[4], iflg) *3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := hamforint(radius,
    center_long,
    false_easting,
    false_northing);
        for_trans := outsys;
    end
    else
    if (outsys = ROBIN) then
    begin
    //* this is the call to initialize ROBINSON
    center_long :=paksz(outparm[4], iflg)* 3600 * S2R;
    if (iflg <> 0) then
    exit; {       return;}
    iflg :=robforint(radius,
    center_long,
    false_easting,
    false_northing);
        for_trans := outsys;
    end
    else
    if (outsys = GOOD) then
    begin
    //* this is the call to initialize GOODE'S HOMOLOSINE
    iflg :=goodforint(radius);
        for_trans := outsys;
    end
    else
    if (outsys = MOLL)then
    begin
    //* this is the call to initialize MOLLWEIDE
    center_long :=paksz(outparm[4],iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg :=molwforint(radius,
    center_long,
    false_easting,
    false_northing);
        for_trans := outsys;
    end
    else
    if (outsys = IMOLL)
    then
    begin
    //* this is the call to initialize INTERRUPTED MOLLWEIDE
    iflg :=imolwforint(radius);
        for_trans := outsys;
    end
    else
    if (outsys =ALASKA) then
    begin
    //* this is the call to initialize ALASKA CONFORMAL
    iflg :=alconforint(r_major,
    r_minor,
    false_easting,
    false_northing);
        for_trans := outsys;
    end
    else
    if (outsys =WAGIV) then
    begin
    //* this is the call to initialize WAGNER IV
    center_long :=paksz(outparm[4], iflg) * 3600 * S2R;
    if (iflg <> 0)then exit; {       return;}
    iflg :=wivforint(radius, center_long,
                     false_easting, false_northing);
        for_trans := outsys;
    end
    else
    if (outsys =WAGVII) then
    begin
    //* this is the call to initialize WAGNER VII
    center_long :=paksz(outparm[4], iflg) * 3600 * S2R;
    if (iflg <>0) then exit; {       return;}
    iflg :=wviiforint(radius, center_long,
                      false_easting, false_northing);
        for_trans := outsys;
    end
    else if (outsys = OBEQA) then
    begin
    //* this is the call to initialize OBLATED EQUAL AREA
    center_long := paksz(outparm[4], iflg) * 3600 * S2R;
    if (iflg<> 0) then exit; {       return;}
    center_lat :=paksz(outparm[5], iflg) * 3600 * S2R;
    if (iflg<> 0) then exit; {       return;}
    shape_m :=outparm[2];
    shape_n :=outparm[3];
    angle :=paksz(outparm[8], iflg) * 3600 * S2R;
    if (iflg<> 0) then exit; {       return;}
    iflg :=obleqforint(radius, center_long, center_lat,
    shape_m, shape_n,angle,false_easting,false_northing);
        for_trans := outsys;
    end
{return;}
end;
//////////////////////////////////////////////////////////////
{  alberfor(lon, lat: double; var x, y: double): Integer;}
{ Albers Conical Equal Area forward equations--mapping lat,long to x,y}
//////////////////////////////////////////////////////////////
procedure DoLLtoXY(
{ForCoords(for_trans: Integer;}
                    LongXCoord, LatYCoord:Double;
                    var XCoord, YCoord:Double);
Begin
Case  for_trans of
0://  GEO:// Integer = 0; //0 = Geographic
Begin{? never called by me?}
  XCoord:= LongXCoord;
  YCoord:=  LatYCoord;
End;
1://  UTM:// Integer = 1; //1 = Universal Transverse Mercator (UTM)
Begin
{  utmfor(lon, lat: double; var x, y: double): Integer;}

utmfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
2://  SPCS:// Integer = 2; //2 = State Plane Coordinates
Begin
{  stplnfor(lon, lat: double; var x, y: double): Integer;}
stplnfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
3://  ALBERS:// Integer = 3; //3 = Albers Conical Equal Area
Begin
{  alberfor(lon, lat: double; var x, y: double): Integer;}
alberfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
4:// LAMCC:// Integer = 4; //4 = Lambert Conformal Conic
Begin
{  lamccfor(lon, lat: double; var x, y: double): Integer;}
lamccfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
5://  MERCAT:// Integer = 5; //5 = Mercator
Begin
{  merfor(lon, lat: double; var x, y: double): Integer;}
merfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
6://  PS:// Integer = 6; //6 = Polar Stereographic
Begin
{  psfor(lon, lat: double; var x, y: double): Integer;}
psfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
7://  POLYC:// Integer = 7; //7 = Polyconic
Begin
{  polyfor(lon, lat: double; var x, y: double): Integer;}
polyfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
8://  EQUIDC:// Integer = 8; //8 = Equidistant Conic
Begin
{  eqconfor(lon, lat: double; var x, y: double): Integer;}
eqconfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
9://  TM:// Integer = 9; //9 = Transverse Mercator
Begin
{  tmfor(lon, lat: double; var x, y: double): Integer;}
tmfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
10://  STEREO:// Integer = 10; //10 = Stereographic
Begin
{  sterfor(lon, lat: double; var x, y: double): Integer;}
sterfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
11://  LAMAZ:// Integer = 11; //11 = Lambert Azimuthal Equal Area
Begin
{  lamazfor(lon, lat: double; var x, y: double): Integer;}
lamazfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
12://  AZMEQD:// Integer = 12; //12 = Azimuthal Equidistant
Begin
{  azimfor(lon, lat: double; var x, y: double): Integer;}
azimfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
13://  GNOMON:// Integer = 13; //13 = Gnomonic
Begin
{  gnomfor(lon, lat: double; var x, y: double): Integer;}
gnomfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
14://  ORTHO:// Integer = 14; //14 = Orthographic
Begin
{ orthfor(lon, lat: double; var x, y: double): Integer;}
orthfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
15://  GVNSP:// Integer = 15; //15 = General Vertical Near-Side Perspective
Begin
{   gvnspfor(lon, lat: double; var x, y: double): Integer;}
gvnspfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
16://  SNSOID:// Integer = 16; //16 = Sinusiodal
Begin
{  sinfor(lon, lat: double; var x, y: double): Integer;}
sinfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
17://  EQRECT:// Integer = 17; //17 = Equirectangular
Begin
{  equifor(lon, lat: double; var x, y: double): Integer;}
equifor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
18://  MILLER:// Integer = 18; //18 = Miller Cylindrical
Begin
{  millfor(lon, lat: double; var x, y: double): Integer;}
millfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
19://  VGRINT:// Integer = 19; //19 = Van der Grinten
Begin
{  vandgfor(lon, lat: double; var x, y: double): Integer;}
vandgfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
20://  HOM:// Integer = 20; //20 = (Hotine) Oblique Mercator
Begin
{  omerfor(lon, lat: double; var x, y: double): Integer;}
omerfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
21://  ROBIN:// Integer = 21; //21 = Robinson
Begin
{  robfor(lon, lat: double; var x, y: double): Integer;}
robfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
22://  SOM:// Integer = 22; //22 = Space Oblique Mercator (SOM)
Begin
{  somfor(lon, lat: double; var y, x: double): Integer;}
somfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
23://  ALASKA:// Integer = 23; // 23 = Alaska Conformal
Begin
{  alconfor(lon, lat: double; var x, y: double): Integer;}
alconfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
24://  GOOD:// Integer = 24; //24 = Interrupted Goode Homolosine
Begin
{  goodfor(lon, lat: double; var x, y: double): Integer;}
goodfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
25://  MOLL:// Integer = 25; //25 = Mollweide
Begin
{  molwfor(lon, lat: double; var x, y: double): Integer;}
molwfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
26://  IMOLL:// Integer = 26; //26 = Interrupted Mollweide
Begin
{  imolwfor(lon, lat: double; var x, y: double): Integer;}
imolwfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
27://  HAMMER:// Integer = 27; //27 = Hammer
Begin
{  hamfor(lon, lat: double; var x, y: double): Integer;}
hamfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
28://  WAGIV:// Integer = 28; //28 = Wagner IV
Begin
{  wivfor(lon, lat: double; var x, y: double): Integer;}
wivfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
29://  WAGVII:// Integer = 29; //29 = Wagner VII
Begin
{  wviifor(lon, lat: double; var x, y: double): Integer;}
wviifor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
30://  OBEQA:// Integer = 30; //30 = Oblated Equal Area
Begin
{  obleqfor(lon, lat: double; var x, y: double): Integer;}
obleqfor(LongXCoord, LatYCoord, XCoord, YCoord);
End;
else {31:}//  USDEF:// Integer = 99; //99 = User defined
Begin
DoProjError(-1,-1,0,0,0);
{ShowMessage('Unsupported format');}
End;

END;{Case}
End;

//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
(* void inv_init(long int insys, long int inzone,
                 double *inparm, long int indatum,
                 char *fn27, char *fn83, long int *iflg,
                 InverseTransFunc inv_trans[])
             /* input system code				*/
              /* input zone number				*/
                 /* input array of projection parameters		*/
               /* input datum code				*/
             /* NAD 1927 parameter file			*/
             /* NAD 1983 parameter file			*/
             /* status flag					*/
                       /* inverse function pointer			*/*)
{Procedure  InvInit(insys,inzone,indatum:Integer; var iflg:Integer);}

procedure InitXYtoLLin;
{InvInit(insys, inzone, indatum: Integer;
                    var inparm: parameters;
                    var iflg,inv_trans: Integer);}
var
insys, inzone, indatum: Integer;
  azimuth, //* azimuth
    angle, //* rotation anlge
    alf, //* SOM angle
{ lon,}//* longitude
  lon1, //* longitude point in utm scene
    lon2, //* 2nd longitude point
{ lat,}//* latitude
  lat1, //* 1st standard parallel
    lat2, //* 2nd standard parallel
    center_long, //* center longitude
    center_lat, //* center latitude
    h, //* height above sphere
    lat_origin, //* latitude at origin
    lon_origin, //* longitude at origin
    r_major, //* major axis in meters
    r_minor, //* minor axis in meters
    scale_factor, //* scale factor
    false_easting, //* false easting in meters
    false_northing, //* false northing in meters
    radius, //* radius of sphere
    shape_m, //* constant used for Oblated Equal Area
    shape_n, //* constant used for Oblated Equal Area
    time: Double; //* SOM time
//double paksz(double ang, long int *iflg);
//* function to convert DMS to DEG		*/
    start, //* start of SOM Beginning or end
    path, //* SOM path number
    satnum, //* SOM satellite number
    mode, //* which format is used	A or B
    tmpdatum, //* temporary datum for UTM
    zone: Integer; //* zone number
begin
//* Initialize inverse transformations
insys:=Round(inparm[15]);
indatum:=Round(inparm[18]);
If inparm[15]=2 then  inzone:= Round(inparm[20])
   else inzone:= Round(inparm[17]);
  //* find the correct major and minor axis
  Spheroidz(indatum, inparm, r_major, r_minor, radius);
  false_easting := inparm[6];
  false_northing := inparm[7];

if (insys = UTM) then
  begin
     //* this is the call to initialize U T M
     //* set Clarke 1866 spheroid if negative datum code
    if (indatum < 0) then
    begin
      tmpdatum := 0;
      Spheroidz(tmpdatum, inparm, r_major, r_minor, radius);
    end;
    zone := inzone;
    if (zone = 0) then
    begin
      lon1 := paksz(inparm[0], iflg) * 3600 * S2R;
      if (iflg <> 0) then exit; {       return;}
      lat1 := paksz(inparm[1], iflg) * 3600 * S2R;
      if (iflg <> 0) then exit; {       return;}
      zone := CalcUtmZone(lon1 * R2D);
      if (lat1 < 0) then zone := -zone;
    end;
    scale_factor := 0.9996;
    iflg := utminvint(r_major, r_minor, scale_factor, zone);
    inv_trans{[insys]} :=UTM;{ utminv;}
  end
  else
if (insys = SPCS) then
    begin
     //* this is the call to initialize STATE PLANE
      iflg := stplninvint(inzone, indatum {,fn27,fn83});
      if (iflg <> 0) then exit; {       return;}
      inv_trans{[insys]} :=SPCS ;{stplninv;}
    end
    else
if (insys = ALBERS) then
   begin
     //* this is the call to initialize ALBERS
        lat1 := paksz(inparm[2], iflg) * 3600 * S2R;
        if (iflg <> 0) then exit; {       return;}
        lat2 := paksz(inparm[3], iflg) * 3600 * S2R;
        if (iflg <> 0) then exit; {       return;}
        center_long := paksz(inparm[4], iflg) * 3600 * S2R;
        if (iflg <> 0) then exit; {       return;}
        lat_origin := paksz(inparm[5], iflg) * 3600 * S2R;
        if (iflg <> 0) then exit; {       return;}
        iflg := alberinvint(r_major, r_minor, lat1, lat2,
          center_long, lat_origin,
          false_easting, false_northing);
     inv_trans{[insys]} :=ALBERS ;{alberinv;}
      end
      else
if (insys = LAMCC) then
        begin
     //* this is the call to initialize LAMBERT CONFORMAL CONIC
          lat1 := paksz(inparm[2], iflg) * 3600 * S2R;
          if (iflg <> 0) then exit; {       return;}
          lat2 := paksz(inparm[3], iflg) * 3600 * S2R;
          if (iflg <> 0) then exit; {       return;}
          center_long := paksz(inparm[4], iflg) * 3600 * S2R;
          if (iflg <> 0) then exit; {       return;}
          lat_origin := paksz(inparm[5], iflg) * 3600 * S2R;
          if (iflg <> 0) then exit; {       return;}
          iflg := lamccinvint(r_major, r_minor, lat1, lat2,
            center_long, lat_origin,
            false_easting, false_northing);
     inv_trans{[insys]} :=LAMCC; {lamccinv;}
        end
        else
if (insys = MERCAT) then
          begin
     //* this is the call to initialize MERCATOR
            center_long := paksz(inparm[4], iflg) * 3600 * S2R;
            if (iflg <> 0) then exit; {       return;}
            lat1 := paksz(inparm[5], iflg) * 3600 * S2R;
            if (iflg <> 0) then exit; {       return;}
            iflg := merinvint(r_major, r_minor, center_long, lat1,
              false_easting,
              false_northing);
     inv_trans{[insys]} :=MERCAT ;{merinv;}
          end
          else
if (insys = PS) then
            begin
     //* this is the call to initialize POLAR STEREOGRAPHIC
              center_long := paksz(inparm[4], iflg) * 3600 * S2R;
              if (iflg <> 0) then exit; {       return;}
              lat1 := paksz(inparm[5], iflg) * 3600 * S2R;
              if (iflg <> 0) then exit; {       return;}
              iflg := psinvint(r_major, r_minor, center_long, lat1,
                false_easting,
                false_northing);
     inv_trans{[insys]} :=PS ;{psinv;}
            end
            else
if (insys = POLYC) then
  begin
     //* this is the call to initialize POLYCONIC
  center_long := paksz(inparm[4], iflg) * 3600 * S2R;
  if (iflg <> 0) then exit; {       return;}
  lat_origin := paksz(inparm[5], iflg) * 3600 * S2R;
  if (iflg <> 0) then exit; {       return;}
  iflg := polyinvint(r_major, r_minor, center_long,
                  lat_origin, false_easting,
                  false_northing);
  inv_trans{[insys]}:= POLYC;{polyinv;}
  end else
if (insys = EQUIDC) then
  begin
     //* this is the call to initialize EQUIDISTANT CONIC
    lat1 := paksz(inparm[2], iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    lat2 := paksz(inparm[3], iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    center_long := paksz(inparm[4], iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    lat_origin := paksz(inparm[5], iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
      {BOOBOO here inparm[8] ??? }
    if (inparm[8] = 0) then mode := 0
    else mode := 1;
    iflg := eqconinvint(r_major, r_minor, lat1, lat2,
                        center_long, lat_origin,
                        false_easting, false_northing, mode);
    inv_trans{[insys]} := EQUIDC; { eqconinv;}
  end else
if (insys = TM) then
  begin
     //* this is the call to initialize TRANSVERSE MERCATOR
    scale_factor := inparm[2];
    center_long := paksz(inparm[4], iflg) * 3600 *  S2R;
    if (iflg <> 0) then exit; {       return;}
    lat_origin := paksz(inparm[5], iflg) * 3600 *  S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := tminvint(r_major, r_minor, scale_factor,
                      center_long, lat_origin,
                      false_easting, false_northing);
    inv_trans{[insys]} := TM; { tminv;}
  end else
if (insys = STEREO) then
  begin
     //* this is the call to initialize STEREOGRAPHIC
    center_long := paksz(inparm[4], iflg) * 3600 *  S2R;
    if (iflg <> 0) then exit; {       return;}
    center_lat := paksz(inparm[5], iflg) * 3600 *  S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := sterinvint(radius, center_long,
                     center_lat, false_easting,
                     false_northing);
    inv_trans{[insys]} := STEREO; { sterinv;}
  end else
if (insys = LAMAZ) then
  begin
     //* this is the call to initialize LAMBERT AZIMUTHAL EQUAL-AREA
    center_long := paksz(inparm[4], iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    center_lat := paksz(inparm[5], iflg) * 3600 *  S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := lamazinvint(radius, center_long,
                        center_lat, false_easting,
                        false_northing);
    inv_trans{[insys]} :=LAMAZ;{ lamazinv;}
  end else
if (insys = AZMEQD) then
  begin
     //* this is the call to initialize AZIMUTHAL EQUIDISTANT
    center_long := paksz(inparm[4], iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    center_lat := paksz(inparm[5], iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := aziminvint(radius, center_long,
                       center_lat, false_easting,
                       false_northing);
    inv_trans{[insys]} := AZMEQD;{aziminv;}
  end else
if (insys = GNOMON) then
  begin
     //* this is the call to initialize GNOMONIC
    center_long := paksz(inparm[4], iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    center_lat := paksz(inparm[5], iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := gnominvint(radius, center_long,
                       center_lat, false_easting,
                       false_northing);
    inv_trans{[insys]}:=GNOMON; {gnominv;}
  end else
if (insys = ORTHO) then
  begin
     //* this is the call to initialize ORTHOGRAPHIC
    center_long := paksz(inparm[4], iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    center_lat := paksz(inparm[5], iflg) *  3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := orthinvint(radius, center_long,
                       center_lat, false_easting,
                       false_northing);
    inv_trans{[insys]} :=ORTHO;{ orthinv;}
  end else
if (insys = GVNSP) then
  begin
     //* this is the call to initialize GENERAL VERTICAL NEAR SIDED PERSPECTIVE
    center_long := paksz(inparm[4], iflg)* 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    center_lat := paksz(inparm[5], iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    h := inparm[2];
    iflg := gvnspinvint(radius, h,
                        center_long, center_lat,
                        false_easting,
                        false_northing);
    inv_trans{[insys]} :=GVNSP;{ gvnspinv;}
  end else
if (insys = SNSOID) then
  begin
     //* this is the call to initialize SINUSOIDAL
    center_long := paksz(inparm[4],iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := sininvint(radius,center_long, false_easting,false_northing);
    inv_trans{[insys]} :=SNSOID;{ sininv;}
  end else
if (insys = EQRECT) then
  begin
     //* this is the call to initialize EQUIRECTANGULAR
    center_long := paksz(inparm[4],iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    lat1 := paksz(inparm[5], iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := equiinvint(radius, center_long, lat1,
                       false_easting, false_northing);
    inv_trans{[insys]} := EQRECT;{equiinv;}
  end else
if (insys = MILLER) then
  begin
    //* this is the call to initialize MILLER CYLINDRICAL
    center_long := paksz(inparm[4], iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := millinvint(radius, center_long,
                      false_easting, false_northing);
    inv_trans{[insys]} :=MILLER;{ millinv;}
  end else
if (insys = VGRINT) then
  begin
    //* this is the call to initialize VAN DER GRINTEN
    center_long := paksz(inparm[4], iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := vandginvint(radius, center_long,
                        false_easting, false_northing);
    inv_trans{[insys]} :=VGRINT{ vandginv;}
  end else
if (insys = HOM) then
  begin
    lat1 := 0;
    lat2 := 0;
    lon1 := 0;
    lon2 := 0;
    azimuth := 0;
    lon_origin := 0;
     //* this is the call to initialize HOTLINE OBLIQUE MERCATOR
    scale_factor := inparm[2];
    lat_origin :=paksz(inparm[5], iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    if (inparm[12] <> 0) then
    begin
      mode := 1;
      azimuth := paksz(inparm[3], iflg) * 3600 * S2R;
      if (iflg <> 0) then exit; {       return;}
      lon_origin := paksz(inparm[4], iflg) * 3600 * S2R;
      if (iflg <> 0) then exit; {       return;}
    end  else
    begin
      mode := 0;
      lon1 := paksz(inparm[8],iflg) * 3600 * S2R;
      if (iflg <> 0) then exit; {       return;}
      lat1 := paksz(inparm[9],iflg) * 3600 * S2R;
      if (iflg <> 0) then exit; {       return;}
      lon2 := paksz(inparm[10], iflg) * 3600 * S2R;
      if (iflg <> 0) then exit; {       return;}
      lat2 := paksz(inparm[11], iflg) * 3600 * S2R;
      if (iflg <> 0) then exit; {       return;}
    end;
    iflg := omerinvint(r_major, r_minor, scale_factor,
                       azimuth, lon_origin, lat_origin,
                       false_easting, false_northing, lon1,
                       lat1,lon2, lat2, mode);
    inv_trans{[insys]} := HOM;{omerinv;}
  end  else
if (insys = SOM) then
  begin
    alf := 0;
    time := 0;
    start:= 0;
    lon1 := 0;
     // this is the call to initialize SOM
    path := Round(inparm[3]);
    satnum := Round(inparm[2]);
    if (inparm[12] = 0) then
    begin
      mode := 1;
      alf := paksz(inparm[3],iflg) * 3600 * S2R;
      if (iflg <> 0) then exit; {       return;}
      lon1 := paksz(inparm[4], iflg) * 3600 * S2R;
      if (iflg <> 0) then exit; {       return;}
      time := inparm[8];
      start :=  Round(inparm[10]);
    end  else
    mode := 0;
      // *iflg = sominvint(r_major,r_minor,satnum,path,
      //   false_easting,false_northing);
    iflg := sominvint(r_major, r_minor, satnum, path,
                      alf, lon1, false_easting,
                      false_northing, time,
                      start, mode);
    inv_trans{[insys]} :=SOM;{ sominv;}
  end else
if (insys = HAMMER) then
  begin
    //* this is the call to initialize HAMMER
    center_long := paksz(inparm[4], iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg :=  haminvint(radius, center_long,
                       false_easting,false_northing);
    inv_trans{[insys]} :=HAMMER {haminv;}
  end else
If (insys = ROBIN) then
  begin
    //* this is the call to initialize ROBINSON
    center_long :=paksz(inparm[4], iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := robinvint(radius, center_long,
                      false_easting,false_northing);
    inv_trans{[insys]} := ROBIN; { robinv;}
  end else
if (insys = GOOD) then
  begin
     //* this is the call to initialize GOODE'S HOMOLOSINE
    iflg :=goodinvint(radius);
    inv_trans{[insys]} := GOOD { goodinv};
  end else
if (insys = MOLL) then
  begin
     //* this is the call to initialize MOLLWEIDE
    center_long := paksz(inparm[4],iflg) * 3600 * S2R;
    if (iflg <> 0) then  exit; {       return;}
    iflg :=  molwinvint(radius, center_long,
                        false_easting, false_northing);
    inv_trans{[insys]}:= MOLL {molwinv};
  end else
if (insys = IMOLL) then
  begin
     //* this is the call to initialize INTERRUPTED MOLLWEIDE
    iflg :=imolwinvint(radius);
    inv_trans{[insys]} :=IMOLL; {imolwinv;}
  end else
if (insys = ALASKA) then
  begin
     //* this is the call to initialize ALASKA CONFORMAL
    iflg := alconinvint(r_major, r_minor,
                        false_easting, false_northing);
    inv_trans{[insys]} :=ALASKA ;{alconinv;}
  end  else
if (insys =WAGIV) then
  begin
     // this is the call to initialize WAGNER IV
    center_long :=  paksz(inparm[4], iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := wivinvint(radius, center_long,
                      false_easting, false_northing);
    inv_trans{[insys]} :=WAGIV ;{wivinv;}
  end else
if (insys =WAGVII) then
  begin
     //* this is the call to initialize WAGNER VII
    center_long := paksz(inparm[4], iflg) * 3600 * S2R;
    if (iflg <> 0) then exit; {       return;}
    iflg := wviiinvint(radius, center_long,
                       false_easting, false_northing);
    inv_trans{[insys]} :=WAGVII ;{wviiinv;}
  end else
if (insys= OBEQA)then
  begin
    //* this is the call to initialize OBLATED EQUAL AREA
    center_long :=paksz(inparm[4], iflg) * 3600 * S2R;
    if (iflg<> 0)then exit; {       return;}
    center_lat :=paksz(inparm[5], iflg) * 3600 * S2R;
    if (iflg<> 0)then exit; {       return;}
    shape_m :=inparm[2];
    shape_n :=inparm[3];
    angle :=paksz(inparm[8], iflg) * 3600 * S2R;
    if (iflg<> 0)then exit; {       return;}
    iflg :=obleqinvint(radius,
                      center_long,
                      center_lat,
                      shape_m,
                      shape_n,
                      angle,
                      false_easting,
                      false_northing);
    inv_trans{[insys]}:=OBEQA; {obleqinv;}
end
{return;}
end;
//////////////////////////////////////////////////////////////

{  alberinv(x, y: double; var lon, lat: double): Integer;}
{Albers Conical Equal Area inverse equations--mapping x,y to lat/long}
//////////////////////////////////////////////////////////////
procedure DoXYtoLL(
{InvCoords(inv_trans: Integer;}
                    XCoord, YCoord:Double;
                    var LongXCoord, LatYCoord:Double);
Begin
Case  inv_trans of
0://  GEO:// Integer = 0; //0 = Geographic
Begin
  LongXCoord:=XCoord;
  LatYCoord:=YCoord;
End;
1://  UTM:// Integer = 1; //1 = Universal Transverse Mercator (UTM)
Begin
{  utmfor(lon, lat: double; var x, y: double): Integer;}
utminv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
2://  SPCS:// Integer = 2; //2 = State Plane Coordinates
Begin
{  stplnfor(lon, lat: double; var x, y: double): Integer;}
stplninv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
3://  ALBERS:// Integer = 3; //3 = Albers Conical Equal Area
Begin
{  alberfor(lon, lat: double; var x, y: double): Integer;}
alberinv(XCoord, YCoord, LongXCoord, LatYCoord);
{alberinv(x, y: double; var lon, lat: double): Integer;}
End;
4:// LAMCC:// Integer = 4; //4 = Lambert Conformal Conic
Begin
{  lamccfor(lon, lat: double; var x, y: double): Integer;}
lamccinv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
5://  MERCAT:// Integer = 5; //5 = Mercator
Begin
{  merfor(lon, lat: double; var x, y: double): Integer;}
merinv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
6://  PS:// Integer = 6; //6 = Polar Stereographic
Begin
{  psfor(lon, lat: double; var x, y: double): Integer;}
psinv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
7://  POLYC:// Integer = 7; //7 = Polyconic
Begin
{  polyfor(lon, lat: double; var x, y: double): Integer;}
polyinv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
8://  EQUIDC:// Integer = 8; //8 = Equidistant Conic
Begin
{  eqconfor(lon, lat: double; var x, y: double): Integer;}
eqconinv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
9://  TM:// Integer = 9; //9 = Transverse Mercator
Begin
{  tmfor(lon, lat: double; var x, y: double): Integer;}
tminv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
10://  STEREO:// Integer = 10; //10 = Stereographic
Begin
{  sterfor(lon, lat: double; var x, y: double): Integer;}
sterinv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
11://  LAMAZ:// Integer = 11; //11 = Lambert Azimuthal Equal Area
Begin
{  lamazfor(lon, lat: double; var x, y: double): Integer;}
lamazinv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
12://  AZMEQD:// Integer = 12; //12 = Azimuthal Equidistant
Begin
{  azimfor(lon, lat: double; var x, y: double): Integer;}
aziminv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
13://  GNOMON:// Integer = 13; //13 = Gnomonic
Begin
{  gnomfor(lon, lat: double; var x, y: double): Integer;}
gnominv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
14://  ORTHO:// Integer = 14; //14 = Orthographic
Begin
{ orthfor(lon, lat: double; var x, y: double): Integer;}
orthinv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
15://  GVNSP:// Integer = 15; //15 = General Vertical Near-Side Perspective
Begin
{   gvnspfor(lon, lat: double; var x, y: double): Integer;}
gvnspinv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
16://  SNSOID:// Integer = 16; //16 = Sinusiodal
Begin
{  sinfor(lon, lat: double; var x, y: double): Integer;}
sininv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
17://  EQRECT:// Integer = 17; //17 = Equirectangular
Begin
{  equifor(lon, lat: double; var x, y: double): Integer;}
equiinv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
18://  MILLER:// Integer = 18; //18 = Miller Cylindrical
Begin
{  millfor(lon, lat: double; var x, y: double): Integer;}
millinv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
19://  VGRINT:// Integer = 19; //19 = Van der Grinten
Begin
{  vandgfor(lon, lat: double; var x, y: double): Integer;}
vandginv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
20://  HOM:// Integer = 20; //20 = (Hotine) Oblique Mercator
Begin
{  omerfor(lon, lat: double; var x, y: double): Integer;}
omerinv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
21://  ROBIN:// Integer = 21; //21 = Robinson
Begin
{  robfor(lon, lat: double; var x, y: double): Integer;}
robinv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
22://  SOM:// Integer = 22; //22 = Space Oblique Mercator (SOM)
Begin
{  somfor(lon, lat: double; var y, x: double): Integer;}
sominv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
23://  ALASKA:// Integer = 23; // 23 = Alaska Conformal
Begin
{  alconfor(lon, lat: double; var x, y: double): Integer;}
alconinv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
24://  GOOD:// Integer = 24; //24 = Interrupted Goode Homolosine
Begin
{  goodfor(lon, lat: double; var x, y: double): Integer;}
goodinv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
25://  MOLL:// Integer = 25; //25 = Mollweide
Begin
{  molwfor(lon, lat: double; var x, y: double): Integer;}
molwinv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
26://  IMOLL:// Integer = 26; //26 = Interrupted Mollweide
Begin
{  imolwfor(lon, lat: double; var x, y: double): Integer;}
imolwinv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
27://  HAMMER:// Integer = 27; //27 = Hammer
Begin
{  hamfor(lon, lat: double; var x, y: double): Integer;}
haminv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
28://  WAGIV:// Integer = 28; //28 = Wagner IV
Begin
{  wivfor(lon, lat: double; var x, y: double): Integer;}
wivinv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
29://  WAGVII:// Integer = 29; //29 = Wagner VII
Begin
{  wviifor(lon, lat: double; var x, y: double): Integer;}
wviiinv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
30://  OBEQA:// Integer = 30; //30 = Oblated Equal Area
Begin
{  obleqfor(lon, lat: double; var x, y: double): Integer;}
obleqinv(XCoord, YCoord, LongXCoord, LatYCoord);
End;
else {31:}//  USDEF:// Integer = 99; //99 = User defined
Begin
DoProjError(-1,-1,0,0,0);
{ShowMessage('Unsupported format');}
End;

END;{Case}
End;
//////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
(* Finds the correct ellipsoid axis
void sphdz(isph,parm,r_major,r_minor,radius)
long isph;		/* spheroid code number				*/
double *parm;		/* projection parameters			*/
double *r_major;	/* major axis					*/
double *r_minor;	/* minor axis					*/
double *radius;		/* radius					*/

//////////////////////////////////////////////////////////////
NAME                           SPHDZ

PURPOSE:	This function assigns values to the semimajor axis, semiminor
		axis, and radius of sphere.  If the spheroid code is negative,
		the first two values in the parameter array (parm) are used
		to define the values as follows:

		--If parm[0] is a non-zero value and parm[1] is greater than
		  one, the semimajor axis and radius are set to parm[0] and
		  the semiminor axis is set to parm[1]. 

		--If parm[0] is nonzero and parm[1] is greater than zero but
		  less than or equal to one, the semimajor axis and radius
		  are set to parm[0] and the semiminor axis is computed
		  from the eccentricity squared value parm[1].  This
		  algorithm is given below.

		--If parm[0] is nonzero and parm[1] is equal to zero, the
		  semimajor axis, radius, and semiminor axis are set to
		  parm[0].

		--If parm[0] equals zero and parm[1] is greater than zero,
		  the default Clarke 1866 is used to assign values to the
		  semimajor axis, radius and semiminor axis.

		--If parm[0] and parm[1] equals zero, the semimajor axis
		  and radius are set to 6370997.0 (This value is represented
	 	  as the last value in the spheroid code array) and the
		  semiminor axis is set to zero.

		if a spheroid code is zero or greater, the semimajor and
		semiminor axis are defined by the spheroid code, listed below
		in the array assignment, and the radius is set to 6370997.0.
		If the spheroid code is greater than SPHDCT the default
		spheroid, Clarke 1866, is used to define the semimajor
		and semiminor axis and radius is set to 6370997.0.

		The algorithm to define the semiminor axis using the
		eccentricity squared value is as follows:

		      semiminor = sqrt(1.0 - ES) * semimajor   where
		      ES = eccentricity squared
THIS Table A IS FROM OLD ONE!!!!!!!   just FYI   !!!!!!!!!!
  Table A:  SUPPORTED DATUMS
   0: Clarke 1866 (default)
   1: Clarke 1880
   2: Bessel
   3: International 1967
   4: International 1909
   5: WGS 72
   6: Everest
   7: WGS 66
   8: GRS 1980/WGS 84
   9: Airy
  10: Modified Everest
  11: Modified Airy
  12: Walbeck
  13: Southeast Asia
  14: Australian National
  15: Krassovsky
  16: Hough
  17: Mercury 1960
  18: Modified Mercury 1968
  19: Sphere of Radius  6370997 meters
THIS Table A IS FROM OLD ONE!!!!!!!   just FYI   !!!!!!!!!!

0: Clarke 1866 (default)
1: Clarke 1880
2: Bessel
3: International 1967
4: International 1909
5: WGS 72
6: Everest
7: WGS 66
8: GRS 1980
9: Airy
10: Modified Everest
11: Modified Airy
12: WGS 84
13: Southeast Asia
14: Australian National
15: Krassovsky
16: Hough
17: Mercury 1960
18: Modified Mercury 1968
19: Sphere of Radius 6370997 meters
20: Bessel 1841(Namibia)
21: Everest (Sabah & Sarawak)
22: Everest (India 1956)
23: Everest (Malaysia 1969)
24: Everest (Malay & Singapr 1948)
25: Everest (Pakistan)
26: Hayford
27: Helmert 1906
28: Indonesian 1974
29: South American 1969
30: WGS 60
-1: UNKNOWN_ELLIPSOID
-2: NO_ELLIPSOID
*)

{function}
procedure Spheroidz(isph: Integer;
  var parm: parameters;
  var r_major, r_minor, radius: double){: Integer};
var tempD,
  t_major, //* temporary major axis
  t_minor: double; //* temporary minor axis
  jsph: Integer; //* spheroid code number
begin
  if (isph < 0) then
  begin
    tempD := parm[0];
    t_major := abs(tempD);
    t_minor := abs(parm[1]);

    // The semimajor axis and the semiminor axis
    // are in the array, assign	them directly
    if (t_major > 0.0) then
    begin
      if (t_minor > 1.0) then
      begin
        r_major := t_major;
        r_minor := t_minor;
        radius := t_major;
      end
      else
     // The semimajor axis and the eccentricity squared values are in the array,
     //	therefore, the semiminor axis is computed from the eccentricity
    //	squared value parm[1]
        if (t_minor > 0.0) then
        begin
          r_major := t_major;
          radius := t_major;
          r_minor := (sqrt(1.0 - t_minor)) * t_major;
        end
        else
     // The semiminor axis is zero or less, assign the semimajor axis to
//	the semiminor axis.
        begin
          r_major := t_major;
          radius := t_major;
          r_minor := t_major;
        end
    end
    else
// The sphroid code is to be used to assign the axis
      if (t_minor > 0.0) then //* t_major = 0 */
       // Assign Clarke 1866 semi-major and semi-minor axis
      begin
        r_major := major[0];
        radius := major[0];
        r_minor := minor[0];
      end
      else
       // Assign Spheroid radius to semi-major and semi-minor axis
      begin
        r_major := major[19{DATMCT - 1}];
        radius := major[19{DATMCT - 1}];
        r_minor := 6370997.0;
      end
  end
  else //* isph >= 0 */
// Use the spheroid code to assign the semi-major and semi-minor axis
  begin
    jsph := abs(isph);
    if (jsph > 19) then
    // The spheroid code is out of range, assign Clarke 1866
    begin
      {PError('Invalid spheroid selection', 'INFORMATIONAL');
      PError('Reset to 0', 'INFORMATIONAL');}
      DoProjError(0,0,0,0,0);
{     isph := 1;}
      jsph := 0;
    end;
// Assign the radius argument to the standard radius value
    r_major := major[jsph];
    r_minor := minor[jsph];
    radius := major[19{DATMCT - 1}];
  end;
{  result := (OK);}
end;
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
(*//////////////////////////////////////////////////////////////
NAME                            UNTFZ
PURPOSE: This function determines the convergence factor between the
 input unit type and the output unit type.  Valid types include:
		1 = U.S. feet                     0 = Radians
		2 = Meters                        3 = Seconds of arc
    5 = International feet            4 = Degrees of arc
  *)

function Untfz(inunit, outunit: Integer; var factor: double):  Integer;
const{ from    UNFTZ static double}
  factors: array[0..5 {6}, 0..5 {6}] of Double
   = (
    (1.0, 0.0, 0.0, 206264.8062470963, 57.29577951308231, 0.0),
    (0.0, 1.0, 0.3048006096012192, 0.0, 0.0, 1.000002000004),
    (0.0, 3.280833333333333, 1.0, 0.0, 0.0, 3.280839895013124),
    (0.484813681109536E-5, 0.0, 0.0, 1.0, 0.27777777777778E-3, 0.0),
    (0.0174532925199433, 0.0, 0.0, 3600, 1.0, 0.0),
    (0.0, 0.999998, 0.3048, 0.0, 0.0, 1.0));
begin
  result := (OK);
  if ((outunit >= 0) and (outunit <= MAXUNIT)
    and (inunit >= 0) and (inunit <= MAXUNIT)) then
  begin
    factor := factors[inunit][outunit];

    if (factor = 0.0) then
    begin
      {PError('Uncompatable unit codes', 'untfz-code'); }
      DoProjError(1101,1101,inunit,outunit,0);
      result := (1101);
      Exit;
    end
  end
  else
  begin
    {PError('Illegal source or target unit code', 'untfz-unit');}
    DoProjError(5,5,0,0,0);
    result := (5);
    Exit;
  end
end;
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////




end.
